
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../common/mmo.h"
#include "../common/malloc.h"

#include "version.h"
#include "char.h"
#include "char_db.h"


#include "db_mysql.h"



void char_db_init() {
	sql_init();
}

void char_db_term() {
	sql_close();
}

int char_db_newchar(const char *name, const char *pass, int totem, int sex, int country, int face, int hair) {
	int result;
	result=char_db_isnameused(name);
	if(result)
		return result;
	if(sql_request("INSERT INTO `char` (`name`, `pass`, `totem`, `money`, `sex`, `country`, `face`, `map`, `x`, `y`, `hair`) VALUES ('%s', '%s', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d','%d')",
					name, pass, totem, start_money, sex, country, face, start_pos.m, start_pos.x, start_pos.y, hair))
		return 2; //db error
	if(sql_request("INSERT INTO `option` (`char_id`,`allow_whisper`,`allow_exchange`,`allow_pvp`,`allow_group`,`eff_magic`,`eff_sound`,`eff_weather`,`showhelm`,`fastmove`,`announce`) VALUE( last_insert_id(), 1,1,1,1,1,1,1,1,1,1 ) "))
		return 2; // db error
	return 0; //new char is ready!
}

int char_db_isnameused(const char *name) {
	if (sql_request("SELECT `id` FROM `char` WHERE `name`='%s'", name))
		return 2; //db error
	if (sql_get_row())
		return 0;  //name is free
	return 1; //name is used
}

unsigned int char_db_idfromname(const char *name) {
	unsigned int result;
	if (sql_request("SELECT `id` FROM `char` WHERE `name`='%s'", name))
		return 0; //db error
	if (sql_get_row())
		return 0;  //unknow charname
	result = sql_get_uint(0);
	return result; //here char id
}

int char_db_setpass(const char *name, const char *pass, const char *newpass) {
	if(sql_request("SELECT `pass` FROM `char` WHERE `name`='%s'", name))
		return -1; //db_error
	if(sql_get_row())
		return -2; //name doesn't exist
	if(strcmp(sql_get_str(0), pass))
		return -3; //wrong password, try again!
	if(sql_request("UPDATE `char` SET `pass`='%s' WHERE `name`='%s'", newpass, name))
		return -1; //db_error
	return 0; //ok
}

int char_db_mapfifofromlogin(const char *name, const char *pass, unsigned int *id) {
	int result;
	if(sql_request("SELECT `id`, `pass`, `ban`, `map` FROM `char` WHERE `name`='%s'", name))
		return -1; //db_error
	if(sql_get_row())
		return -2; //name doesn't exist
	if(strcmp(sql_get_str(1), pass))
		return -3; //wrong password, try again!
	if(sql_get_int(2))
		return -4; //you are banned, go away
	result=mapfifo_from_mapid(sql_get_int(3)); //set mapfifo
	if(result==-1)
		return -5; //chaos is rising
	*id=sql_get_uint(0);
	return result; //all ok, return id number
}

int mmo_char_fromdb(unsigned int id, struct mmo_charstatus *p, char *login_name) {
	int i;
	unsigned int item_num;
//	printf("1:%d\n",p);
	nullpo_chk(p);
	//Char status read
	sql_request("SELECT `name`, `clan_id`, `clan_title`, `title`, `level`, " //0-4
			"`class`, `subclass`, `totem`, `might`, `will`, `grace`, " //5-10
			"`karma`, `hp`, `max_hp`, `mp`, `max_mp`, `exp`, `money`, "//11-17
			"`sex`, `country`, `face`, `hair_color`, `armor_color`, " //18-22
			"`map`, `x`, `y`, `side`, `state`, `hair` " //23-27
			"FROM `char` WHERE `id` = '%u' LIMIT 1", id);

	if(sql_get_row()) {
		p->id = 0;
		return -1;
	}

	if(strcmpi(sql_get_str(0), login_name)) {
		p->id = 0;
		return -1;
	}

	p->id = id;
	memcpy(p->name, login_name, 16);
	p->clan_id = sql_get_uint(1);
	strcpy(p->clan_title, sql_get_str(2));
	strcpy(p->title,  sql_get_str(3));
	p->level = sql_get_int(4);
	p->class = sql_get_int(5);
	p->subclass = sql_get_int(6);
	p->totem = sql_get_int(7);
	p->basemight = sql_get_int(8);
	p->basewill = sql_get_int(9);
	p->basegrace = sql_get_int(10);
	p->karma = sql_get_int(11);
	p->hp = sql_get_uint(12);
	p->basehp = sql_get_uint(13);
	p->mp = sql_get_uint(14);
	p->basemp = sql_get_uint(15);
	p->exp = sql_get_uint(16);
	p->money = sql_get_uint(17);
	p->sex = sql_get_int(18);
	p->country = sql_get_int(19);
	p->face = sql_get_int(20);
	p->hair_color = sql_get_int(21);
	p->armor_color = sql_get_int(22);
	p->last_pos.m = sql_get_int(23);
	p->last_pos.x = sql_get_int(24); 
	p->last_pos.y = sql_get_int(25);
	p->side = sql_get_int(26);
	p->state = sql_get_int(27);
	p->hair= sql_get_int(28);
	sql_free_row();

	//GM Level Read
	sql_request("SELECT `level` FROM `gm` WHERE `char_id`='%u' LIMIT 1",p->id);
	if (!sql_get_row()) {
		p->gm_level = sql_get_int(0);
		sql_free_row();
	}

	//Inventory Read
	sql_request("SELECT `item_id`, `amount`, `dura`, `owner_id`, `real_name` FROM `inventory` WHERE `char_id` = '%u' LIMIT 26", id);
	item_num = sql_num_row();
	for(i=0;i<item_num && i<26;i++) {
		if (sql_get_row())
			break;
		p->inventory[i].id = sql_get_int(0);
		p->inventory[i].amount = sql_get_int(1);
		p->inventory[i].dura = sql_get_int(2);
		p->inventory[i].owner_id = sql_get_int(3);
		strcpy(p->inventory[i].real_name, sql_get_str(4));
	}
	sql_free_row();

	//Equip Read
	sql_request("SELECT `item_id`, `amount`, `dura`, `owner_id`, `real_name`, `vitaup_per`, `manaup_per` FROM `equip` WHERE `char_id` = '%u' LIMIT 14", id);
	item_num = sql_num_row();
	for(i=0;i<item_num && i<14;i++) {
		if (sql_get_row())
			break;
		p->equip[i].id = sql_get_int(0);
		p->equip[i].amount = sql_get_int(1);
		p->equip[i].dura = sql_get_int(2);
		p->equip[i].owner_id = sql_get_int(3);
		strcpy(p->equip[i].real_name, sql_get_str(4));
		p->eqvitaup[i]=sql_get_int(5);
		p->eqmanaup[i]=sql_get_int(6);
	}
	sql_free_row();

	//Skill Read
	sql_request("SELECT `magic_id`, `pos` FROM `magic` WHERE `char_id` = '%u'",id);
	item_num=sql_num_row();
	for(i=0;i<item_num;i++) {
		if (sql_get_row())
			break;
		
		p->skill[sql_get_int(1)]=sql_get_int(0);
	}
	sql_free_row();
	
	//aethers
	sql_request("SELECT `aether`, `magic_id`, `duration`, `pos` FROM `aethers` WHERE `char_id` = '%u' LIMIT 50",id);
	item_num=sql_num_row();
	for(i=0;i<item_num;i++){
		if(sql_get_row())
			break;
		
		p->dura_aether[sql_get_int(3)].aether=sql_get_int(0);
		p->dura_aether[sql_get_int(3)].id=sql_get_int(1);
		p->dura_aether[sql_get_int(3)].duration=sql_get_int(2);
	}
	sql_free_row();
	
	
	sql_request("SELECT `allow_whisper`,`allow_exchange`,`allow_pvp`,`allow_group` FROM `option` WHERE `char_id` = '%u' LIMIT 1",id);
	if(!sql_get_row()) {
		
		p->opt.al_whisp=sql_get_int(0);
		p->opt.al_exchg=sql_get_int(1);
		p->opt.al_pvp=sql_get_int(2);
		p->opt.al_whisp=sql_get_int(3);
		sql_free_row();
	}


	

	//Option Read
	sql_request("SELECT `allow_whisper`,`allow_exchange`,`allow_pvp`,`allow_group`,`eff_magic`,`eff_sound`,`eff_weather`,`showhelm`,`fastmove` FROM `option` WHERE`char_id`=%u LIMIT 1", id);
	sql_get_row();
	p->opt.al_whisp = sql_get_uint(0);
	p->opt.al_exchg = sql_get_uint(1);
	p->opt.al_pvp = sql_get_uint(2);
	p->opt.al_group = sql_get_uint(3);
	p->opt.eff_magic = sql_get_uint(4);
	p->opt.eff_sound = sql_get_uint(5);
	p->opt.eff_weather = sql_get_uint(6);
	p->opt.showhelm = sql_get_uint(7);
	p->opt.fastmove = sql_get_uint(8);
	sql_free_row();
	return 0;
}

int mmo_char_todb(struct mmo_charstatus *p) {
	unsigned int save_id[MAX_GLOBALREG];
	int i, item_num;
	
	nullpo_chk(p);
	//char status save
	sql_request("UPDATE `char` SET `clan_id`='%u', `clan_title`='%s', `title`='%s', `level`='%d', `class`='%d', `subclass`='%d', `totem`='%d', `might`='%d', `will`='%d', `grace`='%d', `karma`='%d', `hp`='%u', `max_hp`='%u', `mp`='%u', `max_mp`='%u', `exp`='%u', `money`='%u', `sex`='%d', `country`='%d', `face`='%d', `hair_color`='%d', `armor_color`='%d', `map`='%d', `x`='%d', `y`='%d', `side`='%d', `state`='%d' WHERE id='%u'",
			p->clan_id, p->clan_title, p->title, p->level,
			p->class, p->subclass, p->totem, p->basemight, p->basewill, p->basegrace,
			p->karma, p->hp, p->basehp, p->mp, p->basemp, p->exp, p->money,
			p->sex, p->country, p->face, p->hair_color, p->armor_color,
			p->last_pos.m, p->last_pos.x, p->last_pos.y, p->side, p->state, p->id);

	//inventory save
	
	memset(save_id, 0, MAX_GLOBALREG*sizeof(unsigned int));
	sql_request("SELECT `id` FROM `inventory` WHERE `char_id` = '%u' LIMIT 26", p->id);
	item_num = sql_num_row();
	for(i=0;i<item_num && i<26;i++) {
		if (sql_get_row())
			break;
		save_id[i] = sql_get_uint(0);
	}
	sql_free_row();
	for(i=0;i<26;i++) {
		if (save_id[i])
			sql_request("UPDATE `inventory` SET `item_id`='%d', `amount`='%d', `dura`='%d', `owner_id`='%d', `real_name`='%s' WHERE `id`='%u'",
					p->inventory[i].id, p->inventory[i].amount, p->inventory[i].dura, p->inventory[i].owner_id,  p->inventory[i].real_name, save_id[i]);
		else
			sql_request("INSERT INTO `inventory` (`char_id`, `item_id`, `amount`, `dura`, `owner_id`, `real_name`) VALUES ('%u', '%d', '%d', '%d', '%d', '%s')",
					p->id, p->inventory[i].id, p->inventory[i].amount, p->inventory[i].dura, p->inventory[i].owner_id, p->inventory[i].real_name);
	}

	//equip save
	memset(save_id, 0, MAX_GLOBALREG*sizeof(unsigned int));
	sql_request("SELECT `id` FROM `equip` WHERE `char_id` = '%u' LIMIT 15", p->id);
	item_num = sql_num_row();
	for(i=0;i<item_num && i<6;i++) {
		if (sql_get_row())
			break;
		save_id[i] = sql_get_uint(0);
	}
	sql_free_row();
	for(i=0;i<6;i++) {
		if (save_id[i])
			sql_request("UPDATE `equip` SET `item_id`='%d', `amount`='%d', `dura`='%d', `owner_id`='%d', `real_name`='%s', `vitaup_per`='%d', `manaup_per`='%d' WHERE `id`='%u'",
					p->equip[i].id, p->equip[i].amount, p->equip[i].dura, p->equip[i].owner_id, p->equip[i].real_name, p->eqvitaup[i], p->eqmanaup[i], save_id[i]);
		else
			sql_request("INSERT INTO `equip` (`char_id`, `item_id`, `amount`, `dura`, `owner_id`, `real_name`, `vitaup_per`, `manaup_per`) VALUES ('%u', '%d', '%d', '%d', '%d', '%s', '%d', '%d')",
					p->id, p->equip[i].id, p->equip[i].amount, p->equip[i].dura, p->equip[i].owner_id, p->equip[i].real_name);
	}

	//skill save
	memset(save_id,0,MAX_GLOBALREG*sizeof(unsigned int));
	sql_request("SELECT `pos` FROM `magic` WHERE `char_id` = '%u' LIMIT 26",p->id, MAX_GLOBALREG);
	item_num=sql_num_row();
	for(i=0;i<26;i++) {
		if(sql_get_row())
			break;
		save_id[sql_get_uint(0)]=1;
	}
	sql_free_row();
	sql_request("DELETE FROM `magic` WHERE `char_id` = '%u'",p->id);
	for(i=0;i<26;i++) {
		
	sql_request("INSERT INTO `magic` (`char_id`,`magic_id`,`pos`) VALUES('%u','%d','%d')",p->id,p->skill[i],i);
	
	}
	
	//aether save
	memset(save_id,0,MAX_GLOBALREG*sizeof(unsigned int));
	sql_request("SELECT `pos` FROM `aethers` WHERE `char_id` = '%u' LIMIT %d",p->id,50);
	item_num=sql_num_row();
	for(i=0;i<item_num && i<50;i++) {
		if(sql_get_row())
			break;
		//save_id[sql_get_uint(0)]=1;
	}
	sql_free_row();
	sql_request("DELETE FROM `aethers` WHERE `char_id` = '%u'",p->id);
	for(i=0;i<50;i++) {
		

	sql_request("INSERT INTO `aethers` (`char_id`,`magic_id`,`pos`,`aether`,`duration`) VALUES('%u','%d','%d','%d','%d')",p->id,p->dura_aether[i].id,i,p->dura_aether[i].aether,p->dura_aether[i].duration);
		
	}
	
	//Reg Save

	//Option Save
	sql_request("UPDATE `option` SET allow_whisper=%d,allow_exchange=%d,allow_pvp=%d,allow_group=%d,eff_magic=%d,eff_sound=%d,eff_weather=%d,showhelm=%d,fastmove=%d WHERE char_id=%u",
		p->opt.al_whisp, p->opt.al_exchg, p->opt.al_pvp, p->opt.al_group, p->opt.eff_magic, p->opt.eff_sound, p->opt.eff_weather, p->opt.showhelm, p->opt.fastmove,p->id);

	//legend save
	//gmlevel save
	if(p->gm_level>0) {
		sql_request("DELETE FROM `gm` WHERE `char_id`='%u'",p->id);
		sql_request("INSERT INTO `gm` (`char_id`,`level`) VALUES ('%u','%d')",p->id,p->gm_level);
 	}
	return 0;
}

void mmo_setonline(unsigned int id, int val) {
	sql_request("UPDATE `char` SET `online`='%d' WHERE `id`='%u'", val, id);
}

void mmo_setallonline(int val) {
	sql_request("UPDATE `char` SET `online`='%d'", val);
}

int mmo_save_reg(unsigned int id, struct registry *reg) {
	int i,c;
	sql_request("DELETE FROM `reg` WHERE `char_id`='%u'", id);
	c=reg->global_num;
	for(i=0;i<c;i++) {
		if(reg->global[i].str[0] && reg->global[i].value[0])
		sql_request("INSERT INTO `reg` (`char_id`,`name`,`val`) VALUES ('%d','%s','%s')", 
			id, reg->global[i].str, reg->global[i].value);
	}

	return 1;
}

int mmo_request_reg(unsigned int id, struct registry *reg) {
	int i,j,c;
	sql_request("SELECT `name`, `val` FROM `reg` WHERE `char_id`='%u'", id);
	c=sql_num_row();
	for(i=0,j=0;i<c;i++) {
		if(sql_get_row())
			break;
		strcpy(reg->global[j].str, sql_get_str(0));
		strcpy(reg->global[j].value, sql_get_str(1));
		j++;
	}
	sql_free_row();
	reg->global_num=j;
	return 0;
}

int mmo_request_legend(unsigned int id, struct legend *leg) {
	int i,j,c;
	sql_request("SELECT `icon`,`color`,`text` FROM `legend` WHERE `char_id`='%u'",id);
	c=sql_num_row();
	for(i=0,j=0;i<c;i++) {
		if(sql_get_row())
			break;
		leg->legends[j].icon = sql_get_uint(0);
		leg->legends[j].color = sql_get_uint(1);
		strcpy(leg->legends[j].text, sql_get_str(2));
		leg->legends[j].len = strlen(leg->legends[j].text);
		j++;
	}
	sql_free_row();
	leg->legend_num=j;
	return 0;
}

int mmo_save_legend(unsigned int id, struct legend *leg) {
	int i,c;
	sql_request("DELETE FROM `legend` WHERE `char_id`='%u'", id);
	c=leg->legend_num;
	for(i=0;i<c;i++) {
		sql_request("INSERT INTO `legend` (`icon`,`color`,`text`) VALUES ('%d','%d','%s')", 
			leg->legends[i].icon, leg->legends[i].color, leg->legends[i].text);
	}

	return 1;
}