
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#ifdef _WIN32
#include <winsock.h>
#include "../mysql/mysql.h"
#endif
#include "../common/core.h"
#include "db_mysql.h"

#define atoui(x) strtoul((x), NULL, 10)
#define MAX_SQL_BUFFER  65535
char last_request[MAX_SQL_BUFFER];

MYSQL mysql_handle;
MYSQL_RES*      sql_res = NULL;
MYSQL_ROW       sql_row = NULL;

int sql_port = 3306;
char sql_ip[16] = "127.0.0.1";
char sql_id[32] = "root";
char sql_pw[32] = "45476027";
char sql_db[32] = "yuri";

#define LOWER(c)   (((c)>='A'  && (c) <= 'Z') ? ((c)+('a'-'A')) : (c))
#define UPPER(c)   (((c)>='a'  && (c) <= 'z') ? ((c)+('A'-'a')) : (c) )

int strncasecmp(const char *arg1, const char *arg2, size_t n)
{
  int chk, i;

  if (arg1 == NULL || arg2 == NULL) {
    printf("strncasecmp(): received a NULL pointer, %p or %p.\n", arg1, arg2);
    return (0);
  }

  for (i = 0; (arg1[i] || arg2[i]) && (n > 0); i++, n--)
    if ((chk = LOWER(arg1[i]) - LOWER(arg2[i])) != 0)
      return (chk);	/* not equal */

  return (0);
}

void sql_set_port(int p) {
	sql_port = p;
}

void sql_set_ip(const char *p) {
	strncpy(sql_ip,p,15);
}

void sql_set_id(const char *p) {
	strncpy(sql_id,p,31);	
}

void sql_set_pw(const char *p) {
	strncpy(sql_pw,p,31);	
}

void sql_set_db(const char *p) {
	strncpy(sql_db,p,31);	
}

void sql_init() {
	memset(last_request, 0, MAX_SQL_BUFFER);
	mysql_init(&mysql_handle);
	if(!mysql_real_connect(&mysql_handle, sql_ip, sql_id, sql_pw,
				sql_db ,sql_port, (char *)NULL, 0)) {
		printf ("SQL_ERR: %s\n",mysql_error(&mysql_handle));
		add_log("SQL_ERR: %s\n",mysql_error(&mysql_handle));
		exit(1);
	}
	printf("Connected to MySQL Server!\n");
}

void sql_close() {
	mysql_close(&mysql_handle);
}

void sql_free_row() {
	if (sql_res) {
		mysql_free_result(sql_res);
		sql_res = NULL;
		sql_row = NULL;
	}
}

int sql_request(const char *format, ...) {
	va_list args;

	if (format == NULL || *format=='\0') return 0;

	if(strncasecmp(last_request, "SELECT", 6) == 0 ||
	   strncasecmp(last_request, "OPTIMIZE", 8) == 0)
		sql_free_row();

	va_start(args, format);
	vsprintf(last_request, format, args);
	va_end(args);

	if(mysql_query(&mysql_handle, last_request) ) {
		printf ("SQL_ERR: %s\n Req: %s\n", mysql_error(&mysql_handle), last_request);
		return -1;
	}

	if(strncasecmp(last_request, "SELECT", 6) == 0 ||
	   strncasecmp(last_request, "OPTIMIZE", 8) == 0)
		sql_res = mysql_store_result(&mysql_handle);

	return 0;
}

int sql_get_row(void) {
	if ( ! sql_res ) return 0;

	sql_row = mysql_fetch_row(sql_res);

	if (!sql_row) return -1;

	return 0;
}

char *sql_get_str(int num_col) {
	char *result = NULL;
	if ( ! sql_res ) return NULL;

	if ( !sql_row ) {
		printf("SQL_ERR: Access to Null Sql Row\n Col: %d, Req:%s\n", num_col, last_request);
		return NULL;
	}

	if (sql_row[num_col]) {
		result = sql_row[num_col];
	}

	return result;
}

int sql_get_int(int num_col) {
	int result = 0;
	if ( ! sql_res ) return -1;

	if ( !sql_row ) {
		printf("SQL_ERR: Access to Null Sql Row\n Col: %d, Req:%s\n", num_col, last_request);
		return -1;
	}

	if (sql_row[num_col]) {
		result = atoi(sql_row[num_col]);
	}

	return result;
}

unsigned int sql_get_uint(int num_col) {
	unsigned int result = 0;
	if ( ! sql_res ) return -1;

	if ( !sql_row ) {
		printf("SQL_ERR: Access to Null Sql Row\n Col: %d, Req:%s\n", num_col, last_request);
		return -1;
	}

	if (sql_row[num_col]) {
		result = atoui(sql_row[num_col]);
	}

	return result;
}

unsigned int sql_num_row(void) {
	if (sql_res) return mysql_num_rows(sql_res);
	return 0;
}

