
#ifndef _MMO_H_
#define _MMO_H_

#define FIFOSIZE_SERVER 131072
#define MAX_MAP_SERVER	5
#define MAX_MAP_PER_SERVER 65535
#define MAX_GLOBALREG 32
#define MAX_SCRIPT_ID 256
#define MAX_REG_NUM 96
#define GLOBAL_REG_NUM 96
#define ACCOUNT_REG_NUM 64
#define ACCOUNT_REG2_NUM 16
#define MAX_LEGEND 128


struct point {
	unsigned short m;
	unsigned short x,y;
};

struct item {
	unsigned short id;
	unsigned short amount;
	unsigned short dura;
	unsigned int owner_id;
	char real_name[64];
};

struct legend_data {
	unsigned char icon;
	unsigned char color;
	short len;
	char text[256];
};

struct skill_info {
	unsigned int duration;
	unsigned int aether;
	unsigned short id;
};

struct global_reg {
	char str[32];
	char value[256]; // [zBuffer]
};

struct registry {
	int global_num;
	struct global_reg global[GLOBAL_REG_NUM];
};

struct legend {
	int legend_num;
	struct legend_data legends[MAX_LEGEND];
};
struct chr_script_data {
	int id;
	char type;
	void *data;
};

struct mmo_charstatus {
	unsigned int id;
	char name[16], title[32], gm_level;
	unsigned int clan_id;
	char clan_title[32];
	unsigned char level, totem, class, subclass;
	unsigned char might, will, grace;
	unsigned int hp;
	unsigned int mp;
	unsigned int exp, money;
	unsigned int basehp,basemp;
	char basemight,basewill,basegrace;
	char sex, country, state, side, karma;
	char face, hair, hair_color, armor_color;
	struct point last_pos;
	struct item equip[14];
	int eqmanaup[14];
	int eqvitaup[14];
	struct item inventory[26];
	unsigned short skill[52];
	
	int legend_count;
	struct skill_info dura_aether[50];
	int global_reg_num;

	struct {
		unsigned al_whisp:1;
		unsigned al_group:1;
		unsigned al_exchg:1;
		unsigned al_pvp:1;
		unsigned showhelm:1;
		unsigned announce:1;
		unsigned eff_magic:1;
		unsigned eff_sound:1;
		unsigned eff_weather:1;
		unsigned fastmove:1;
	} opt;
	
//	struct chr_script_data chr_script_dat[MAX_SCRIPT_ID];

};

struct clan_data {
	char name[32];
	short name_len;
	int id;

	void *member_db;


};


#endif
