
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../common/db.h"
#include "../common/malloc.h"
#include "../common/core.h"
#include "itemdb.h"
#include "map.h"
#include "script.h"
#include "../common/nullpo.h"
//struct dbt *item_db;
struct item_data *item_db[0xFFFF]={0,};
int max_itemdb;

struct cash_data cashs;



int itemdb_searchname_sub(void *key,void *data,va_list ap) {
	struct item_data *item=(struct item_data *)data,**dst;
	char *str;
	str=va_arg(ap,char *);
	dst=va_arg(ap,struct item_data**);
	if(strcmpi(item->yname,str)==0)
		*dst=item;
	return 0;
}

struct item_data* itemdb_searchname(const char *str) {
	int i;
	for(i =0; i< max_itemdb; i++) {
		if(!item_db[i]) continue;
		if(strcmp(str,item_db[i]->name) == 0) {
			return item_db[i];
		}
	}
	return NULL;
}




int itemdb_id(char *str) {
	struct item_data *db=NULL;
	db=itemdb_searchname(str);
	if (db)
		return db->id;

	if (atoi(str)>0) {
		db=itemdb_searchexist(atoi(str));
		if (db)
			return db->id;
	}
	return 0;
}




	
int itemdb_read(const char *itemdb_file) {
	FILE *fp;
	char line[1024];
	int lines=0;
	char *str[45], *p, *np;
	struct item_data *db;
	int i, itm=0;
	int j=0;
	fp = fopen(itemdb_file, "r");
	if (fp==NULL) {
		printf("DB_ERR: Can't read item db (%s).", itemdb_file);
		exit(1);
	}

	while (fgets(line,sizeof(line)-1,fp)) {
		lines++;
		if ((line[0] == '/' && line[1] == '/') || line[0]=='#')
			continue;
		memset(str,0,sizeof(str));
		for(i=0,np=p=line;i<39 && p;i++) {
			str[i]=p;
			p=strchr(p,',');
			if(p){ *p++=0; np=p; }
		}
		
		itm++;
		db=NULL;
		//num,name,yuri name,type,price,sell,max_amount //0-6
		//  class,sex,lvl,look,look_color,icon,icon_color //7-13
		//  sound,dura,might,will,grace,{use/equip script},{unequip script} //14-19
		db = itemdb_search(atoi(str[0]));
		if(db) {
//			printf("line: %c %c %c\n",line[0],line[1],line[2]);
			if(atoi(str[0])) printf("itemdb: fix item_db, there are overlapped item id %d. line %d\n",atoi(str[0]),lines);
			continue;
		}
//		printf("itemdb: item data %d read done.\n",atoi(str[0]));
		CREATE(db,struct item_data, 1);
		db->id=atoi(str[0]);
		item_db[db->id]=db;
		if(db->id >= max_itemdb) max_itemdb=db->id+1;
		
		strcpy(db->name, str[1]); // ̸
		strcpy(db->yname, str[2]); // ̸
		db->type=atoi(str[3]); // Ÿ
		db->price=atoi(str[4]); // 
		db->max_amount=atoi(str[5]); //ִ 
		db->max_have=atoi(str[6]); //   ֳ
		db->class=atoi(str[7]); // 
		db->subclass=atoi(str[8]); // ±
		db->sex=atoi(str[9]); // 
		db->level=atoi(str[10]); //
		db->look=atoi(str[11]); // 
		db->look_color=atoi(str[12]);// 
		db->icon=49151+atoi(str[13]); // ۸ 
		db->icon_color=atoi(str[14]); // ۸
		db->sound=atoi(str[15]); // Ҹ
		db->dura=atoi(str[16]); // 
		db->might=atoi(str[17]); //
		db->ac=atoi(str[18]); //
		db->hit=atoi(str[19]); // 
		db->dam=atoi(str[20]); //
		db->vita=atoi(str[21]); //ü
		db->vita_per=atoi(str[22]); // ü % ø°
		db->mana=atoi(str[23]); // 
		db->mana_per=atoi(str[24]); //  % ø°
		db->protection=atoi(str[25]); //
		db->healing=atoi(str[26]); // 
		db->min_dam_l=atoi(str[27]); // ּҵ
		db->max_dam_l=atoi(str[28]); // ִ뵥
		db->min_dam_s=atoi(str[29]); // ּҵ
		db->max_dam_s=atoi(str[30]); // ִ뵥
		db->die=atoi(str[31]); //  ?
		db->drop=atoi(str[32]); // ֳ
		db->fix=atoi(str[33]); // ĥֳ
		db->naming=atoi(str[34]); //Ҽֳ
		strcpy(db->unitchar,str[35]);
		db->unitchar[strlen(str[35])-1]=NULL;
		db->might_up=atoi(str[36]);
		db->will_up=atoi(str[37]);
		db->grace_up=atoi(str[38]);
		// for debug
		//if(db->id==1) printf("debug %d\n",db->max_have);
//		printf("%s\n",db->unitchar);
/*
unsigned drop:1; // users can be droping the item?
	unsigned fix:1; // users can be fixing the item?
	unsigned naming:1; // users can be naming the item?
	char die; // drop when the users die?
	char unitchar[10]; // unit character for smoke
*/
		if(db->script) {
			aFree(db->script);
			db->script=NULL;
		}

		if(db->equip_script) {
			aFree(db->equip_script);
			db->equip_script=NULL;
		}

		if(db->unequip_script) {
			aFree(db->unequip_script);
			db->unequip_script=NULL;
		}

		if((p=strchr(np,'{'))==NULL)
				continue;
			
			str[39] = p; //Script
			np = strchr(p,'}');
			
			while (np && np[1] && np[1] != ',')
				np = strchr(np+1,'}'); //Jump close brackets until the next field is found.
			if (!np || !np[1]) {
				//Couldn't find the end of the script field.
				db->script = parse_script((unsigned char *) str[39],itemdb_file,lines);
				continue;
			}

			np[1] = '\0'; //Set end of script
			db->script = parse_script((unsigned char *) str[39],itemdb_file,lines);
//			printf("script: %s\n",db->script);
			np+=2; //Skip to next field

		if(!np || (p=strchr(np,'{'))==NULL)
				continue;
			
			str[40] = p; //Script
			np = strchr(p,'}');
			
			while (np && np[1] && np[1] != ',')
				np = strchr(np+1,'}'); //Jump close brackets until the next field is found.
			if (!np || !np[1]) {
				//Couldn't find the end of the script field.
				db->equip_script = parse_script((unsigned char *) str[40],itemdb_file, lines);
				continue;
			}

			np[1] = '\0'; //Set end of script
			db->equip_script = parse_script((unsigned char *) str[40],itemdb_file,lines);
			np+=2; //Skip to next field

		if(!np || (p=strchr(np,'{'))==NULL)
				continue;
			
			db->unequip_script = parse_script((unsigned char *)p,itemdb_file,lines);
	}
	

	fclose(fp);
	printf("Item db read done. %d item loaded!\n", itm);
	return 0;
}

static int itemdb_final(void *key,void *data,va_list ap) {
	struct item_data *db;
	nullpo_ret(db=data);

	aFree(db->script);
	aFree(db);

	return 0;
}

int itemdb_term() {
	int i;
	for(i=0; i< max_itemdb; i++) {
		if(item_db[i]) aFree(item_db[i]);
	}
	return 0;
}

int itemdb_init() {
	itemdb_read(ITEMDB_FILE);
	cashs.gold=itemdb_id(map_msg[MAP_CASH_GOLD].message);
	cashs.dong=itemdb_id(map_msg[MAP_CASH_DONG].message);
	cashs.dongs=itemdb_id(map_msg[MAP_CASH_DONGS].message);
	cashs.silver= itemdb_id(map_msg[MAP_CASH_SILVER].message);
	cashs.silvers=itemdb_id(map_msg[MAP_CASH_SILVERS].message);
	return 0;
}

int itemdb_checkifcash(int id) {
	if( cashs.gold == id ||
		cashs.dong == id || 
		cashs.dongs == id ||
		cashs.silver == id ||
		cashs.silvers == id) return 1;

	return 0;
}

