
#ifndef _ITEM_H_
#define _ITEM_H_

#define ITEMDB_FILE "db/item_db.txt"

enum {
	EQ_WEAP,
	EQ_ARMOR,
	EQ_SHIELD,
	EQ_HELM,
	EQ_LEFT,
	EQ_RIGHT,
	EQ_SCRIPT1,
	EQ_SCRIPT2,
	EQ_FACEACC,
	EQ_CROWN,
	EQ_MANTLE,
	EQ_NECKLACE,
	EQ_BOOTS,
	EQ_COAT
};

enum {
	ITM_EAT, //0
	ITM_USE, //1
	ITM_SMOKE, //2
	ITM_WEAP, //3
	ITM_ARMOR, //4
	ITM_SHIELD, //5
	ITM_HELM, //6
	ITM_HAND, //7
	ITM_SCRIPT, //8
	ITM_FACEACC, //9
	ITM_WEAP_2H, // 10
	ITM_USESPC, // 11 - Ư
	ITM_ETC, //2

	
};

enum {
	ITMDIE_NONE,
	ITMDIE_DROP,
	ITMDIE_BREAK,
};
struct cash_data {
	int gold;
	int silver;
	int silvers;
	int dong;
	int dongs;
};
struct item_data {
	unsigned short id;
	char name[32];
	char yname[32];
	unsigned char type;
	int price;
	int max_amount;
	
	unsigned char class;
	unsigned char subclass;
	unsigned char sex;
	unsigned char level;
	unsigned short look;
	unsigned char look_color;
	unsigned short icon;
	unsigned char icon_color;
	unsigned char sound;
	int dura;
	unsigned char might;
	unsigned char ac;
	unsigned char dam;
	unsigned char hit;
	unsigned int vita;
	unsigned short vita_per;
	unsigned int mana;
	unsigned short mana_per;
	unsigned int protection;
	unsigned int healing;
	unsigned int min_dam_l;
	unsigned int max_dam_l;
	unsigned int min_dam_s;
	unsigned int max_dam_s;
	unsigned max_have:1;
	unsigned drop:1; // users can be droping the item?
	unsigned fix:1; // users can be fixing the item?
	unsigned naming:1; // users can be naming the item?
	char die; // drop when the users die?
	char unitchar[10]; // unit character for smoke

	unsigned char might_up;
	unsigned char will_up;
	unsigned char grace_up;
	
	char *script;
	char *equip_script;
	char *unequip_script;
};

extern struct item_data *item_db[0xFFFF];

#define itemdb_mindam_l(id) item_db[id]->min_dam_l
#define itemdb_maxdam_l(id) item_db[id]->max_dam_l
#define itemdb_mindam_s(id) item_db[id]->min_dam_s
#define itemdb_maxdam_s(id) item_db[id]->max_dam_s
#define itemdb_unitchar(id) item_db[id]->unitchar
#define itemdb_icon(id) item_db[id]->icon
#define itemdb_iconcolor(id) item_db[id]->icon_color
#define itemdb_type(id) item_db[id]->type
#define itemdb_level(id) item_db[id]->level
#define itemdb_might(id) item_db[id]->might
#define itemdb_grace(id) item_db[id]->grace
#define itemdb_will(id) item_db[id]->will
#define itemdb_sex(id) item_db[id]->sex
#define itemdb_script(id) item_db[id]->script
#define itemdb_vita(id) item_db[id]->vita
#define itemdb_mana(id) item_db[id]->mana
#define itemdb_vita_per(id) item_db[id]->vita_per
#define itemdb_mana_per(id) item_db[id]->mana_per
#define itemdb_ac(id) item_db[id]->ac
#define itemdb_dam(id) item_db[id]->dam
#define itemdb_hit(id) item_db[id]->hit
#define itemdb_unequipscript(id) item_db[id]->unequip_script
#define itemdb_equipscript(id) item_db[id]->equip_script
#define itemdb_search(id) item_db[id]
#define itemdb_searchexist(id) item_db[id]
#define itemdb_name(id) item_db[id]->name
#define itemdb_maxamount(id) item_db[id]->max_amount
#define itemdb_maxhave(id) item_db[id]->max_have
#define itemdb_sound(id) item_db[id]->sound
#define itemdb_dura(id) item_db[id]->dura
#define itemdb_look(id) item_db[id]->look
#define itemdb_lookcolor(id) item_db[id]->look_color
#define itemdb_protection(id) item_db[id]->protection
#define itemdb_might_up(id) item_db[id]->might_up
#define itemdb_will_up(id) item_db[id]->will_up
#define itemdb_grace_up(id) item_db[id]->grace_up
#define itemdb_class(id) item_db[id]->class
#define itemdb_subclass(id) item_db[id]->subclass

struct item_data* itemdb_searchname(const char*);

int itemdb_id(char *str);


int itemdb_read();
int itemdb_term();
int itemdb_init();
int itemdb_checkifcash(int id);
extern struct cash_data cashs;
#endif
