#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "magic.h"
#include "map.h"
#include "../common/db.h"
#include "../common/malloc.h"
#include "../common/core.h"
#include "script.h"
#include "../common/nullpo.h"
struct magic_data *magic_db[0xFFFF];
int max_spelldb;
//struct magic_data static_mgdb[] = {
//	{0, magic_warpgate }, //񿵻õ 
//	{1, magic_blahblah }
//};
// We don't suppose to use SLOW scripting in the magic. [Lene]
// Temporary using script... [Lene]
// I'll make whole spells as builtin.
// Server admins can only set the effects.
//-------------------------------------------------------

int magic_warpgate( struct map_sessiondata *sd, int mgid )
{
	
}

//int magic_

int magicdb_searchname_sub(void *key,void *data,va_list ap) {
	struct magic_data *item=(struct magic_data *)data,**dst;
	char *str;
	str=va_arg(ap,char *);
	dst=va_arg(ap,struct magic_data**);
	if(strcmpi(item->yname,str)==0)
		*dst=item;
	return 0;
}

struct magic_data* magicdb_searchname(const char *str) {
	int i;
	for(i=0; i<max_spelldb; i++) {
		if(!magic_db[i]) continue;
		if(strcmp(str,magic_db[i]->name) == 0) {
			return magic_db[i];
		}
	}
	return NULL;
}



int magicdb_id(char *str) {
	struct magic_data *db=NULL;
	db=magicdb_searchname(str);
	if (db)
		return db->id;

	if (atoi(str)>0) {
		db=magicdb_searchexist(atoi(str));
		if (db)
			return db->id;
	}
	return 0;
}

	
int magicdb_read(const char *magicdb_file) {
	FILE *fp;
	char line[1024];
	int lines=0;
	char *str[7], *p, *np;
	struct magic_data *db;
	int i, mag=0;
	
	fp = fopen(magicdb_file, "r");
	if (fp==NULL) {
		printf("DB_ERR: Can't read magic db (%s).", magicdb_file);
		exit(1);
	}

	while (fgets(line,sizeof(line),fp)) {
		lines++;
		if (line[0] == '/' && line[1] == '/')
			continue;
		memset(str,0,sizeof(str));
		for(i=0,np=p=line;i<5 && p;i++) {
			str[i]=p;
			p=strchr(p,',');
			if(p){ *p++=0; np=p; }
		}
		
		mag++;
		//num,name,yuri name,type,price,sell,max_amount //0-6
		//  class,sex,lvl,look,look_color,icon,icon_color //7-13
		//  sound,dura,might,will,grace,{use/equip script},{unequip script} //14-19
		db = magicdb_search(atoi(str[0]));
		if(db) {
			printf("fix magic_db, there are overlapped spell id.\n");
			continue;
		}
		CREATE(db, struct magic_data, 1);
		db->id=atoi(str[0]);
		magic_db[db->id]=db;
		if(db->id >= max_spelldb) max_spelldb=db->id+1;
		strcpy(db->name, str[1]);
		strcpy(db->yname, str[2]);
		db->type=atoi(str[3]);
		strcpy(db->question,str[4]);
		//strcpy(db->script,str[5]);
		//strcpy(db->script2,str[6]);
		if(db->script) {
			aFree(db->script);
			db->script=NULL;
		}
		if(db->script2) {
			aFree(db->script2);
			db->script=NULL;
		}
		if((p=strchr(np,'{'))==NULL)
				continue;
			
			str[5] = p; //Script
			np = strchr(p,'}');
			
			while (np && np[1] && np[1] != ',')
				np = strchr(np+1,'}'); //Jump close brackets until the next field is found.
			if (!np || !np[1]) {
				//Couldn't find the end of the script field.
				db->script = parse_script((unsigned char *) str[5],magicdb_file,lines);
				continue;
			}

			np[1] = '\0'; //Set end of script
			db->script = parse_script((unsigned char *) str[5],magicdb_file,lines);
			np+=2; //Skip to next field

		if(!np || (p=strchr(np,'{'))==NULL)
				continue;
			
			str[6] = p; //Script
			np = strchr(p,'}');
			
			while (np && np[1] && np[1] != ',')
				np = strchr(np+1,'}'); //Jump close brackets until the next field is found.
			if (!np || !np[1]) {
				//Couldn't find the end of the script field.
				db->script2 = parse_script((unsigned char *) str[6],magicdb_file,lines);
				continue;
			}

			np[1] = '\0'; //Set end of script
			db->script2 = parse_script((unsigned char *) str[6],magicdb_file,lines);
			np+=2; //Skip to next field

		if(!np || (p=strchr(np,'{'))==NULL)
				continue;
			
			db->script3 = parse_script((unsigned char *)p,magicdb_file,lines);


		
		
		
		
	}
	fclose(fp);
	printf("Magic db read done. %d magic loaded!\n", mag);
	
	return 0;
}

static int magicdb_final(void *key,void *data,va_list ap) {



//	aFree(db->script);

	return 0;
}

int magicdb_term() {
	int i;
	for(i=0;i<max_spelldb;i++) {
		if(magic_db[i]) {
			aFree(magic_db[i]->script);
			aFree(magic_db[i]->script2);
			aFree(magic_db[i]->script3);
			if(magic_db[i]) aFree(magic_db[i]);
		}
	}
	return 0;
}

int magicdb_init() {
	
	magicdb_read(MAGICDB_FILE);
	return 0;
}


