
#ifndef _MAGIC_H_
#define _MAGIC_H_

#define MAGICDB_FILE "db/magic_db.txt"

#include "../common/mmo.h"

struct static_magic {
	int id;
//	char name[32]; // For hangul...
	int (*func)( struct map_sessiondata*, struct magic_data*, int);
};

struct magic_data {
	int id;
	char name[32];
	char yname[32];
	char* script;
	char* script2;
	char* script3;
	char question[32];
	int type;
	unsigned short effect;
	unsigned short sound;
	int aether;
	void *data;
};

// use link-list for skill dura
//-------------------------------

struct skill_info_list {
	int count;
	struct skill_info *first;
	struct skill_info *last;

};

extern struct magic_data *magic_db[0xFFFF];



#define magicdb_name(id) (magic_db[id])?magic_db[id]->name:0
#define magicdb_question(id) (magic_db[id])?magic_db[id]->question:0
#define magicdb_type(id) (magic_db[id])?magic_db[id]->type:0
#define magicdb_script(id) (magic_db[id])?magic_db[id]->script:0
#define magicdb_script2(id) (magic_db[id])?magic_db[id]->script2:0
#define magicdb_script3(id) (magic_db[id])?magic_db[id]->script3:0

#define magicdb_search(id) (magic_db[id])?magic_db[id]:0
#define magicdb_searchexist(id) (magic_db[id])?magic_db[id]:0

int magicdb_id(char *str);

int magicdb_read();
int magicdb_term();
int magicdb_init();

#endif
