
#ifndef _MAP_H_
#define _MAP_H_

#include <stdarg.h>
#include "script.h"
#include "../common/mmo.h"
#include "warp.h"
#include "npc.h"
#include "trade.h"
#define AUTH_FIFO_SIZE 32
#define BLOCK_SIZE 8
#define AREAX_SIZE 17
#define AREAY_SIZE 19

#define NPC_START_NUM 1073741823
#define MAX_NPC 100000000
#define FLOORITEM_START_NUM 2047483647
#define MAX_FLOORITEM 100000000
#define MOB_START_NUM 3047483648
#define MAX_MOB 100000000
#define MAX_MONEY 100000000
#define MAX_EVENTQUEUE 2
#define MAX_EVENTTIMER 32

#define MAP_NAME_LENGTH 64

enum { BL_NUL, BL_PC, BL_NPC, BL_ITEM, BL_MOB };
enum { FLOOR, SCRIPT, SHOP, MOB };

enum { SP_HP, SP_MP, SP_MHP, SP_MMP, SP_ZENY };

enum {	MAP_WHISPFAIL,
	MAP_ERRGHOST,
	MAP_ERRHORSE,
	MAP_ERRINVIS,
	MAP_ERRITMLEVEL,
	MAP_ERRITMMIGHT,
	MAP_ERRITMGRACE,
	MAP_ERRITMWILL,
	MAP_ERRITMSEX,
	MAP_ERRITMCFULL,
	MAP_ERRITMFULL,
	MAP_ERRITMFULL2,
	MAP_ERRITMCLASS,
	MAP_ERRITMSUBCLASS,
	MAP_ERRITM2H,
	MAP_ERRITM_WITH2H,
	MAP_ERREXPMAX,
	MAP_GETEXP,
	MAP_ERRMONEYMAX,
	MAP_EQHELM,
	MAP_EQWEAP,
	MAP_EQARMOR,
	MAP_EQSHIELD,
	MAP_EQRIGHT,
	MAP_EQLEFT,
	MAP_EQSCRIPT1,
	MAP_EQSCRIPT2,
	WP_LVMAX,
	WP_LVMIN,
	WP_LVMIN2,
	WP_LVMIN3,
	MAP_CASH_GOLD, // ݵ
	MAP_CASH_SILVER, // 
	MAP_CASH_SILVERS, // ġ
	MAP_CASH_DONG, // 
	MAP_CASH_DONGS, // ġ
	MAP_EQUIP_ITEM,
	MAP_HASTO_CLASS,
	MAP_ERR_EX_NOTALLOWED,
	MAP_ERR_EX_NOTALLOWED_P,
	MAP_ERR_EX_ALREADY_DOING,
	MAP_ERR_EX_NOTOSELF,
	MAP_EX_CANCLED,
	MAP_EX_CANCLE,
	MAP_EX_OK,
	MAP_ERR_EX_TERMINATED,
	MAP_WHISPER_ON,
	MAP_WHISPER_OFF,
	MAP_EX_ON,
	MAP_EX_OFF,
	MAP_GROUP_ON,
	MAP_GROUP_OFF,
	MAP_PVP_ON,
	MAP_PVP_OFF,
	MAP_GROUP_OUT,
	MAP_GROUP_NOTOSELF,
	MAP_GROUP_NOTALLOWED,
	MAP_GROUP_NOTALLOWED_P,
	MAP_GROUP_JOIN,
	MAP_GROUP_ALREADYJOIN,
	MAP_GROUP_NOTJOIND,
	MAP_GROUP_NOTEXIST_P,
	MAP_WELCOME,
	MSG_MAX
};

#define cap_value(a, min, max) (a>max?max:a<min?min:a)

extern struct map_msg_data {
	char message[256];
	int len;
} map_msg[MSG_MAX];

struct n_post {
    struct n_post *prev;
    unsigned int pos;
};

struct block_list {
	struct block_list *next, *prev;
    unsigned int id;
	unsigned int graphic_id;
	unsigned int graphic_color;
	unsigned short m, x, y;
	unsigned char type;
	unsigned char subtype;
	void *data;
};


struct mobspawn_data {
    struct block_list bl;
    struct skill_info da[100];
    int bx;
    int by;
 	int id;
    int current_vita;
    int startx;
    int starty;
    int state;
    int ac;
    int side;
    int time;
    int num;
    int attacker;
    int canmove;
    int parastate;
    int target;
    char *npc_script,*npc_scriptroot;
    struct script_data *npc_stackbuf;
    int reg_num;
    struct script_reg *reg;
    int regstr_num;
    struct script_regstr *regstr;
    int npc_stack,npc_stackmax;
};

struct script_reg {
	int index;
	int data;
};

struct script_regstr {
	int index;
	char data[256];
};

struct map_sessiondata {
	struct block_list bl;
	int fd;
	//mmo
	struct mmo_charstatus status;
	//status
	unsigned int max_hp,max_mp;
	unsigned char might,will,grace;
	int ac,min_dam_l,max_dam_l,min_dam_s,max_dam_s;
	int protection;
	int hit,dam; 
	int regen;
	//npc
	int npc_id;
	int npc_pos;
	int npc_lastpos;
	int npc_menu;
	int npc_amount;
	int npc_g;
	int npc_gc;
	int npc_prev;
	int target;
	int time;
	int lasttime;
	int timer;
	int npc_stack,npc_stackmax;
	char *npc_script,*npc_scriptroot;
	struct script_data *npc_stackbuf;
	int regentimer;
	int disguise,disguise_color;
	int backstab,flank,polearm;
	int tooclose;
	int rage;
	//register
	int reg_num;
	struct script_reg *reg;
	int regstr_num;
	struct script_regstr *regstr;
	struct n_post npcp;
	struct script_state *st;
	struct {
		unsigned menu_or_input:1;
		unsigned reg_dirty : 3;
		unsigned leg_dirty : 1;
	} state;
	
	struct { 
		struct {
			int index, amount;
		} item[10];
		int money;
	} deal;

	char eventqueue[MAX_EVENTQUEUE][50];
	int eventtimer[MAX_EVENTTIMER];
	unsigned short eventcount; // [celest]
	
	char npc_str[256];
	int npc_timer_id;
	struct registry save_reg;
	struct trade_data *trade_info;
	struct group_data *group_info;
	int group_leader;


	int selectshopid;
	int selectshopcount;
	int targetslot;
	int targetitemid;
	int itemamount;
	struct legend legend_list;

};
struct npc_timerevent_list {
	int timer,pos;
};
struct npc_label_list {
	char name[NAME_LENGTH];
	int pos;
};
struct npc_item_list {
	unsigned int nameid,value;
};
struct npc_data {
	struct block_list bl;
	char name[NAME_LENGTH];
	char exname[NAME_LENGTH];
	union {
		struct {
			struct script_code *script;
			short xs,ys;
			int timer,timerid,timeramount,rid;
			unsigned int timertick;
			struct npc_timerevent_list *timer_event;
			int label_list_num;
			struct npc_label_list *label_list;
			int src_id;
		} scr;
		struct npc_item_list shop_item[1];
		struct {
			short xs,ys;
			short x,y;
			unsigned short mapindex;
		} warp;
	} u;

	int eventtimer[MAX_EVENTTIMER];
};

struct npc_shop_data {
	int id;
	int itemcount;
	int itemid[256];
	unsigned int sellprice[256];
	unsigned int buyprice[256];
};

struct auth_data {
	unsigned int id;
	unsigned int ip;
	char name[16];
};

struct map_data {
	char title[64];
	unsigned short id;
	struct block_list **block;
	struct block_list **block_npc;
	struct mobspawn_data **block_mob;
	int *block_count, *block_npc_count;
	int block_mob_count;
	unsigned short xs, ys, bxs, bys;
	unsigned char *map;
	unsigned short *tile, *obj, *pass;
	int user;
	unsigned char bgm;
	//map server other data
	unsigned int ip; 
	unsigned short port;

	struct warp_data *wl_head;
	struct warp_data *wl_last;
	struct point warp_gate[6];
	short warp_gate_range[6];
	struct {
		unsigned noteleport:1;
		unsigned warp:1;
	} flag;
};	

struct userlist_data {
	unsigned int user_count;
	unsigned int user[10000];
};
#define map_isloaded(m) (map[m].tile)
#define read_map(m,x,y) (map[m].map[(x)+(y)*map[m].xs])
#define read_tile(m,x,y) (map[m].tile[(x)+(y)*map[m].xs])
#define read_obj(m,x,y) (map[m].obj[(x)+(y)*map[m].xs])
#define read_pass(m,x,y) (map[m].pass[(x)+(y)*map[m].xs])



struct flooritem_data {
	struct block_list bl;
	struct item data;
	unsigned int gone_tick;
};

extern struct map_data map[];
extern int map_n;
extern struct userlist_data userlist;
extern struct auth_data auth_fifo[];
extern int auth_n;

extern int char_fd;
extern char char_id[];
extern char char_pw[];

extern int map_ip;
extern unsigned short map_port;

extern int save_time;
extern int dump_save;
extern char item_infos[];
extern char db_path[];

extern int char_ip;
extern unsigned short char_port;

struct map_sessiondata* map_id2sd(unsigned int);
struct map_sessiondata* map_name2sd(char*);

void map_clritem();
void map_delitem(unsigned int);
void map_additem(struct block_list*);

void map_deliddb(unsigned int);
void map_addiddb(struct block_list*);

int map_setmapip(int,unsigned int,unsigned short);
int map_freeblock(void*);
int map_freeblock_lock();
int map_freeblock_unlock();
int map_addblock(struct block_list*);
int map_delblock(struct block_list*);
int map_foreachincell(int (*)(struct block_list*,va_list),int,int,int,int,...);
int map_foreachinarea(int (*)(struct block_list*,va_list),int,int,int,int,int,...);
int map_foreachinblock(int (*)(struct block_list*,va_list),int,int,int,int,int,int,...);
int map_foreachinblockva(int (*)(struct block_list*,va_list),int,int,int,int,int,int,va_list);
int map_canmove(int,int,int);
int map_addspawn(struct mobspawn_data*);
struct block_list* map_id2bl(unsigned int id);

struct block_list* map_firstincell(int,int,int,int);
struct block_list* map_firstincell_Reverse(int,int,int,int);
struct block_list* map_firstincell2(int m,int x,int y,int type);
int map_read(int,const char*,int,const char*);
int map_readall();
int map_src_add(const char*);
int map_src_clear();
int map_adduserlist(struct map_sessiondata*);
int map_deluserlist(struct map_sessiondata*);
int lang_read(const char*);
int config_read(const char*);

void help_screen();
void do_term(void);
struct block_list *map_getlastblock(struct block_list* root);

extern int xp_rate;
extern int d_rate;
#endif
