
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include "../common/malloc.h"
#include "map.h"
#include "mob.h"
#include "../common/db.h"
#include "clif.h"
#include "../common/nullpo.h"
#include "magic.h"
#include "itemdb.h"
#include "pc.h"

unsigned int mob_id=MOB_START_NUM;

unsigned int mob_get_new_id();
int max_mobdb;
struct mobdb_data *mobdb[0xFFFF]={0,};
#define MOB_LARGE 'l'
#define MOB_SMALL 's'




unsigned int mob_get_new_id() {
	return mob_id++;
}



int mobdb_read(const char *mobdb_file) {
	FILE *fp;
	char line[1024];
	int lines=0;
	char *str[1024], *p, *np;
	struct mobdb_data *db;
	int i, mstr=0;
	int count=0;
	fp = fopen(mobdb_file, "r");
	if (fp==NULL) {
		printf("DB_ERR: Can't read mob db (%s).", mobdb_file);
		exit(1);
	}
	
	//printf("Loading...%s\n",mobdb_file);
		while (fgets(line,sizeof(line)-1,fp)) {
		count = 0;	
		lines++;
		if ((line[0] == '/' && line[1] == '/') || line[0]=='#')
			continue;
		memset(str,0,sizeof(str));
		for(i=0,np=p=line;i<30 && p;i++) {
			str[i]=p;
			p=strchr(p,',');
			if(p){ count++;  *p++=0; np=p; }
		}
		count++;

		count-= 17;

		mstr++;

		//num,name,hyul name,type,look,lookcolor,vita,base experience,attack damage
		//drop1,drop2,drop3,drop4,drop5,drop6,drop7,drop8
		
		//type: 0=Normal, 1=Aggressive, 2=chicken 3=Stationary(such as trees)
		//printf("%d\n",atoi(str[0]));
		db = mobdb_search(atoi(str[0]));
		if(db!=NULL) {
			printf("mobdb: fix mob_db, there are same mob id.\n");
			continue;
		} 
		CREATE(db,struct mobdb_data,1);
		
		db->id=atoi(str[0]);
		mobdb[db->id]=db;
		if(max_mobdb<=db->id) max_mobdb=db->id+1;
        strcpy(db->name, str[1]);
		strcpy(db->yname, str[2]);
		db->type=atoi(str[3]);
		db->look=atoi(str[4]);
		db->look_color=atoi(str[5]);
		db->vita=atoi(str[6]);
		db->exp=atoi(str[7]);
		db->attack=atoi(str[8]);
		db->movetime=atoi(str[9]);
		db->spawntime=atoi(str[10]);
		db->sizetype=atoi(str[11]);
		db->ac=atoi(str[12]);
		for(i=0;i<count;i++){	
			if(sscanf(str[13+i],"%d:%d:%d",&db->drop[i],&db->drop_count[i],&db->drop_rate[i]) != 3) {
				ShowWarning("   ߸ :[%s]\n",db->name);
			}
			db->dropitemcount++;
		}
		//  str[72]  .

		if(db->attack_script) {
			aFree(db->attack_script);
			db->attack_script=NULL;
		}
		
		if(db->attacked_script) {
			aFree(db->attacked_script);
			db->attacked_script=NULL;
		}

		if(db->move_script) {
			aFree(db->move_script);
			db->move_script=NULL;
		}

		if(db->die_script) {
			aFree(db->die_script);
			db->die_script=NULL;
		}

			if((p=strchr(np,'{'))==NULL)
			{
				printf("Couldn't Find { \n");
				continue;
			}
			str[73] = p; //Script
			np = strchr(p,'}');
			
			while (np && np[1] && np[1] != ',')
				np = strchr(np+1,'}'); //Jump close brackets until the next field is found.
			if (!np || !np[1]) {
				ShowError("Couldn't find the end of the script field.\n");
				db->attack_script = parse_script((unsigned char *) str[73],mobdb_file,lines);
				continue;
			}

			np[1] = '\0'; //Set end of script
			db->attack_script = parse_script((unsigned char *) str[73],mobdb_file,lines);
//			printf("script: %s\n",db->script);
			np+=2; //Skip to next field


			if(!np || (p=strchr(np,'{'))==NULL)
			{
				printf("Couldn't Find { (2)\n");
				continue;
			}
			
			str[74] = p; //Script
			np = strchr(p,'}');
			
			while (np && np[1] && np[1] != ',')
				np = strchr(np+1,'}'); //Jump close brackets until the next field is found.
			if (!np || !np[1]) {
				//Couldn't find the end of the script field.
				db->attacked_script = parse_script((unsigned char *) str[74],mobdb_file, lines);
				continue;
			}

			np[1] = '\0'; //Set end of script
			db->attacked_script = parse_script((unsigned char *) str[74],mobdb_file,lines);
			np+=2; //Skip to next field


			if(!np || (p=strchr(np,'{'))==NULL) {
				printf("Couldn't Find { (3)\n");
				continue;
			}
			
			str[75] = p; //Script
			np = strchr(p,'}');
			
			while (np && np[1] && np[1] != ',')
				np = strchr(np+1,'}'); //Jump close brackets until the next field is found.
			if (!np || !np[1]) {
				//Couldn't find the end of the script field.
				db->move_script = parse_script((unsigned char *) str[75],mobdb_file, lines);
				continue;
			}
			np[1] = '\0'; //Set end of script
			db->move_script = parse_script((unsigned char *) str[75],mobdb_file,lines);
			np+=2; //Skip to next field

			
			if(!np || (p=strchr(np,'{'))==NULL) {
				printf("Couldn't Find { (4)\n");
				continue;
			}
			db->die_script = parse_script((unsigned char *)p,mobdb_file,lines);
	}

	fclose(fp);
	printf("Monster db read done. %d monsters loaded!\n", mstr);
	return 0;
}


int mobspawn_onetime(int id,int m, int x,int y) {
	struct mobspawn_data *db;
	int new_id;
	CREATE(db, struct mobspawn_data,1);
	new_id=mob_get_new_id();
	
	
	db->bl.m=m;
	db->startx=x;
	db->starty=y;
	db->id=id;
	db->state=MOB_DEAD;
	db->bl.type=BL_MOB;
	db->bl.x=db->startx;
	db->bl.y=db->starty;
	db->bl.id=new_id;
	db->bl.prev=NULL;
	db->bl.next=NULL;
	
	db->time=0;
	db->ac=mobdb_ac(db->id);
	db->attacker=0;

	//map_addblock(&db->bl);
	map_addiddb(&db->bl);
	map_addspawn(db);
	return 0;
}
int mobspawn_read(const char *mobspawn_file) {
	FILE *fp;
	char line[1024];
	int lines=0;
	char *str[5], *p, *np;
	struct mobspawn_data *db;
	int i, mstr=0;
	int new_id;
	
	fp = fopen(mobspawn_file, "r");
	if (fp==NULL) {
		printf("DB_ERR: Can't read mob db (%s).", mobspawn_file);
		exit(1);
	}

	
	while (fgets(line,sizeof(line),fp)) {
		lines++;
		if (line[0] == '/' && line[1] == '/')
			continue;
		memset(str,0,sizeof(str));
		for(i=0,np=p=line;i<5 && p;i++) {
			str[i]=p;
			p=strchr(p,',');
			if(p){ *p++=0; np=p; }
		}
		
		mstr++;
		//map,startx,starty,id
		CREATE(db, struct mobspawn_data,1);
		new_id=mob_get_new_id();
		
   		
   		db->bl.m=atoi(str[0]);
		db->startx=atoi(str[1]);
		db->starty=atoi(str[2]);
		db->id=atoi(str[3]);
		db->state=MOB_DEAD;
		db->bl.type=BL_MOB;
		db->bl.x=db->startx;
		db->bl.y=db->starty;
		db->bl.id=new_id;
		db->bl.prev=NULL;
		db->bl.next=NULL;
		
		db->time=0;
		db->ac=mobdb_ac(db->id);
		//map_addblock(&db->bl);
		map_addiddb(&db->bl);
		map_addspawn(db);
		
	//	if ((p = strchr(np, '{')) != NULL)
//			db->script = parse_script((unsigned char*)np, lines);
	}

	fclose(fp);
	srand( gettick() );
	printf("Monster spawn read done. %d monsters spawned!\n", mstr);
	return 0;
}
int mobspawn2_read(const char *mobspawn_file) {
	FILE *fp;
	char line[1024];
	int lines=0;
	char *str[5], *p, *np;
//	struct mobspawn_data *db;
	int i, mstr=0;
	int new_id;
	int id;
	int m,times,max,x,y,a,z;
	
	fp = fopen(mobspawn_file, "r");
	if (fp==NULL) {
		printf("DB_ERR: Can't read mob db (%s).", mobspawn_file);
		exit(1);
	}

	
	while (fgets(line,sizeof(line),fp)) {
		lines++;
		if (line[0] == '/' && line[1] == '/')
			continue;
		memset(str,0,sizeof(str));
		for(i=0,np=p=line;i<4 && p;i++) {
			str[i]=p;
			p=strchr(p,',');
			if(p){ *p++=0; np=p; }
		}
		
		mstr++;
		//map,startx,starty,id
		m=atoi(str[0]);
		
		id=atoi(str[1]);
		times=atoi(str[2]);
		for(z=0;z<times;z++) {
reloopit:
		x=rand()%map[m].xs;
		y=rand()%map[m].ys;
		max=map[m].block_mob_count;
		for(a=1;a<max;a++){
			if(map[m].block_mob[a]->startx==x && map[m].block_mob[a]->starty==y)
				goto reloopit;
		}
		
		mobspawn_onetime(id,m,x,y);
		
		}
	}

	fclose(fp);
	printf("Monster random spawns read done. %d monsters spawned!\n", mstr);
	return 0;
}
int mobspeech_read(char* mobspeech_file) {
	return 0;
}



int mobdb_id(char *str) {
	struct mobdb_data *db=NULL;
	db=mobdb_searchname(str);
	if (db)
		return db->id;
	
	if (atoi(str)>0) {
		db=mobdb_searchexist(atoi(str));
		if (db) {
			return db->id;
		}
	}
	return 0;
}





int mobdb_init() {
	//char *MOBDB2_FILE="db/mob_db.txt";
	char *MOBSPAWN_FILE="db/spawn_db.txt";
	mobdb_read(MOBDB_FILE);
	mobspawn_read(MOBSPAWN_FILE);
	mobspawn2_read("db/mob_db2.txt");
	return 0;
}

struct mobdb_data* mobdb_searchname(const char *str) {
	int i;
	for(i=0;i<max_mobdb;i++) {
		if(!mobdb[i]) continue;
		if(strcmp(str,mobdb[i]->name) ==0) {
			return mobdb[i];
		}
	}
	return NULL;
}

int mobdb_searchname_sub(void *key,void *data,va_list ap) {
	struct mobdb_data *mob=(struct mobdb_data *)data,**dst;
	char *str;
	str=va_arg(ap,char *);
	dst=va_arg(ap,struct mobdb_data**);
	if(strcmpi(mob->yname,str)==0)
		*dst=mob;
	return 0;
}


int mob_handle(int tid, int tick, int maxmap,int nothing2) {
	int x;
	int y;
	int max;
	x=maxmap;
	if(map[x].block_mob_count>0){ 
		max=map[x].block_mob_count+1;
		for(y=1;y<max;y++){
			mob_handle_magic(map[x].block_mob[y]);
			mob_handle_sub(map[x].block_mob[y]);
		}
	}
	return 0;
}

int mob_delete(int x) {
	int y,max;
	if(map[x].block_mob_count>0){ 
		max=map[x].block_mob_count+1;
		for(y=1;y<max;y++){
			aFree(map[x].block_mob[y]);
		}
	}
	return 0;
}

int mob_handle_magic(struct mobspawn_data *mob) {
	int x;
	for(x=0;x<50;x++) {
		if((mob->da[x].duration>0) && (mob->da[x].id>0)) {
			mob->da[x].duration-=250;
			if(mob->da[x].duration<=0) {
				mob->target=mob->bl.id;
				run_script(magicdb_script2(mob->da[x].id),0,mob->bl.id,0);
			}
		}
	}

	return 0;
}
int mobdb_drops(int id,int m, int x, int y) {
	int rate;
	int z;
	int i;
	int amount;
		
	for(z=0;z<8;z++){
		rate=rand()%10000;
		if((mobdb_itemrate(id,z)*d_rate)>=rate){
			i=mobdb_itemid(id,z);
			amount=mobdb_itemamount(id,z);
			if(i>0) {
				//for(a=0;a<amount;a++){
					mobdb_dropitem(i,amount,m,x,y);
				//}
			}
		}
	}
	
	return 0;
	
}

int mob_damaged( struct mobspawn_data *mob, int damage) {

// calculate damage mobs got finally
	int last_dam=damage;
	int dam_plus;
	nullpo_ret(mob);
	if(mob->ac== 0) return damage;
	dam_plus=damage/mob->ac;
	last_dam+=dam_plus;
	mob->current_vita-=last_dam;
//	printf("mob_damaged(): %d %d %d %d\n",damage,mob->ac,dam_plus,last_dam);
	return last_dam;
}

int mobdb_dropitem(int id,int amount,int m, int x, int y) {
	struct flooritem_data *fl;
	
	CREATE(fl,struct flooritem_data,1);
	
	fl->bl.m=m;
	fl->bl.x=x;
	fl->bl.y=y;
	fl->data.id=id;
	fl->data.amount=amount;
	strcpy(fl->data.real_name, itemdb_name(id));

	map_additem(&fl->bl);
	map_foreachinarea(clif_itemlook_sub,m,x,y,AREA,BL_PC,LOOK_SEND,fl);
	
	return 0;
}
int mob_handle_sub(struct mobspawn_data *mob) {
		
	struct map_sessiondata *sd;
	int type=mobdb_type(mob->id);
	if(!mob->id || !mobdb[mob->id]) {
//		printf("error: mob db NULL\n");
		return 0; // NULL pointer
	}	
	mob->time+=250;
	if(mob->parastate>=2) {
//		printf("error: mob parastate >=2\n");
		return 0;
	}
//	if(strcmp(mobdb_name(mob->id),"")==0) printf("%s state: %d %d\n",mobdb_name(mob->id), mob->state, mobdb_type(mob->id));
	switch(mob->state){
	case MOB_DEAD:
//		printf("spawning start.. values %d,%d,%d\n",mob->state,mob->time,spawntime);
		if(mob->time>=mobdb_spawntime(mob->id)){
			
			mob_respawn(mob);
		//	printf("%d,\n",mobdb_spawntime(mob->id));
		//	printf("Spawned monsters\n");	
		}
		break;
	case MOB_ALIVE:
		
		if(mob->time>=mobdb_movetime(mob->id) && type != MOB_STATIONARY){
			if(mob->parastate==0) {
				
				if(type==MOB_AGGRESSIVE && mob->target==0) {
					map_foreachinarea(mob_find_target,mob->bl.m,mob->bl.x,mob->bl.y,AREA,BL_PC,mob);
				} 
				if(mob->target) {
					mob->state=MOB_HIT;
					move_mob_intent(mob, map_id2sd(mob->target));
				} else {
					move_mob(mob);
				}
				mob->time=0;
			}
			//printf("%d\n",mobdb_movetime(mob->id));
		} else {
			if(type==MOB_AGGRESSIVE && mob->target==0) {
				map_foreachinarea(mob_find_target,mob->bl.m,mob->bl.x,mob->bl.y,AREA,BL_PC,mob);
			}
			if(mob->target) {
				mob->state=MOB_HIT;
				move_mob_intent(mob, map_id2sd(mob->target));
			}
		}
		
		break;
		
		
	case MOB_HIT:
		if(mob->time>((float)mobdb_movetime(mob->id)*0.75)){

			if(mob->parastate==0) {

				mob->time=0;
				sd=map_id2sd(mob->attacker);
				if( sd==NULL || sd->status.id!=mob->attacker || sd->bl.m!=mob->bl.m || sd->status.state==PC_DIE) {
					printf("sd is NULL or?\n");
					mob->state=MOB_ALIVE;
					move_mob(mob);
					if(mobdb_type(mob->id)==MOB_AGGRESSIVE) {
						map_foreachinarea(mob_find_target,mob->bl.m,mob->bl.x,mob->bl.y,AREA,BL_PC,mob);
					}
				} else {
					move_mob_intent(mob,sd);
				}
			} /*else {
				// ...?
			}*/
			
		}
		break;
		
	case MOB_RUN:
		move_mob(mob);
	default:
		break;
	}
	
	
	return 0;
}

int move_mob(struct mobspawn_data* mob){
	int direction;
	int backx;
	int backy;
	char bside;
	int m;
	static last;
	int dx,dy;
	int cm;
	struct point p;
//	int i=0;
	m=mob->bl.m;
	backx=mob->bl.x;
	backy=mob->bl.y;
	dx=backx;
	dy=backy;
	
	
	direction=rand()%4;
	bside=mob->side;
	mob->side=direction;
	
	//run_script(mobdb[mob->id]->move_script,0,0,mob->bl.id);
	switch(direction){
	case 0: //UP
		if(backy>1) {
			dy=backy-1;
		}
		break;
	case 1: //Right
		if(backy<map[m].xs){
			
			dx=backx+1;
			
		}
		break;
	case 2: //down
		if(backy<map[m].ys){
			
			dy=backy+1;
			
		}
		break;
	case 3: //left
		if(backx>1){
			
			dx=backx-1;
			
		}
		break;
	default:
		break;
	}
	map_foreachincell(mob_move,m,dx,dy,BL_MOB,mob);
	map_foreachincell(mob_move,m,dx,dy,BL_PC,mob);
	map_foreachincell(mob_move,m,dx,dy,BL_NPC,mob);
	p.m=m;
	p.x=dx;
	p.y=dy;

	// if there is port? 
	// mob can't go there
	if(search_locate(&p)!=NULL) {
		mob->canmove=1;
	}
	
	cm=mob->canmove;
	if((map_canmove(m,dx,dy)==1) || (mob->canmove==1)) {
		dx=backx;
		dy=backy;
		mob->side=bside;
	} 
	
	if ( dx!=backx || dy!=backy) {
		map_delblock(&mob->bl);
		mob->bx=backx;
		mob->by=backy;
		mob->time=0;
		mob->bl.x=dx;
		mob->bl.y=dy;
		map_addblock(&mob->bl);
		map_foreachinarea(clif_mob_move,m,mob->bl.x,mob->bl.y,AREA,BL_PC,LOOK_SEND,mob);
		mob->canmove=0;
	} else {
		mob->canmove=0;
		return 1;
	}
	
	return 0;
}

int mob_respawn(struct mobspawn_data *mob) {
	
	mob->state=MOB_ALIVE;
	mob->bl.x=mob->startx;
	mob->bl.y=mob->starty;
	mob->current_vita=mobdb_getvita(mob->id);
	mob->time=0;
	mob->attacker=0;
	mob->parastate=0;
	map_addblock(&mob->bl);
	map_foreachinarea(clif_mob_look,mob->bl.m,mob->bl.x,mob->bl.y,AREA,BL_PC,LOOK_SEND,mob);
	return 0;
}
int mob_find_target(struct block_list *bl, va_list ap) {
	struct mobspawn_data *mob;
	struct map_sessiondata *sd;
	
	nullpo_ret(mob=va_arg(ap,struct mobspawn_data*));
//	nullpo_ret(mob=(struct mobspawn_data*)bl);
	
	nullpo_ret(sd=(struct map_sessiondata*)bl);

	mob->attacker=sd->bl.id;
	mob->state=MOB_HIT;
//	ShowDebug("id:%d\n",mob->id);
	ShowDebug(" %s  %s\n",mobdb_name(mob->id), sd->status.name);
	return 0;
}

int move_mob_intent(struct mobspawn_data *mob,struct map_sessiondata *sd) {
	int mx,my;
	int px,py;
	int ax,ay;
	int side;
	mx=mob->bl.x;
	my=mob->bl.y;
	px=sd->bl.x;
	py=sd->bl.y;
	ax=abs(mx-px);
	ay=abs(my-py);
	side=mob->side;
	printf("move_mob_intent() called\n");
	if((ax==0 && ay==1) || (ax==1 && ay==0)) { //means we are next to the player
		if(mx<px) mob->side=1;
		if(mx>px) mob->side=3;
		if(my<py) mob->side=2;
		if(my>py) mob->side=0;
		if(side!=mob->side) clif_sendmob_side(mob);
		mob_attack(mob,sd); //attack the SOB
	} else {
		
		if(mx < px && ay==0) mob_move2(mob,mx+1,my,1);
		else if(mx > px && ay==0) { mob_move2(mob,mx-1,my,3); }
		else if(my < py && ax==0) { mob_move2(mob,mx,my+1,2); }
		else if(my > py && ax==0) { mob_move2(mob,mx,my-1,0); }
		else if(mx < px && ay>0) { mob_move2(mob,mx+1,my,1); }
		else if(mx > px && ay>0) { mob_move2(mob,mx-1,my,3); }
		else if(my < py && ax>0) { mob_move2(mob,mx,my+1,2); }
		else if(my > py && ay>0) { mob_move2(mob,my,my-1,0); }
	}
	
	
	return 0;
}			

int mob_attack(struct mobspawn_data *mob, struct map_sessiondata *sd) {
	//check to see if it hit	
	//check for critical
	//if critical, ignore ac, do 3x damage
	//if no critical, do normal(check ac)
	int id=mob->id;
	int damage=random_range(mobdb[id]->attack,mobdb[id]->attack/10);

	if(sd->status.state == 1) return 0;
	
	clif_sendmob_action(mob,1,9,14);
	pc_damaged(sd,damage);
	clif_sendstatus(sd);
	clif_send_pc_health(sd,sd,damage,33);
//	clif_send_pc_health(sd,sd,0);
	
	return 0;
}

int mob_calc_damage( struct mobspawn_data *mob, struct map_sessiondata *sd ) {
	return 1;
}
int mob_move2(struct mobspawn_data *mob, int x, int y, int side) {

	int m;
	static last;
	int cm;
	m=mob->bl.m;
	mob->side=side;
	map_foreachincell(mob_move,m,x,y,BL_MOB,mob);
	map_foreachincell(mob_move,m,x,y,BL_PC,mob);
	map_foreachincell(mob_move,m,x,y,BL_NPC,mob);
	cm=mob->canmove;
	if(map_canmove(m,x,y)==0 && cm==0) {
		map_delblock(&mob->bl);
		mob->bx=mob->bl.x;
		mob->by=mob->bl.y;
		mob->time=0;
		mob->bl.x=x;
		mob->bl.y=y;
		map_addblock(&mob->bl);
		map_foreachinarea(clif_mob_move,m,mob->bl.x,mob->bl.y,AREA,BL_PC,LOOK_SEND,mob);
	}
	mob->canmove=0;
	return 0;
}

int mob_move(struct block_list *bl, va_list ap) {
	struct mobspawn_data *mob;
	
	nullpo_ret(mob=va_arg(ap,struct mobspawn_data*));
	
	mob->canmove=1;
	return 0;
}
    
int mob_die(struct block_list *bl) {
	return 1;

}

void mobdb_final() {
	int i;

	// free mob db
	for(i=0;i<max_mobdb;i++) {
		if(mobdb[i]) {
			aFree(mobdb[i]);
		}
	}

	// free spawn db
	for(i=0;i<MAX_MAP_PER_SERVER;i++) {
		if(map_isloaded(i)) {
			mob_delete(i);
		}
	}	

}