
#ifndef _MOB_H_
#define _MOB_H_


#define MOBDB_FILE "db/mob_db.txt"
//#define MOBSPAWN_FILE "db/spawn_db.txt"
enum {MOB_ALIVE,MOB_DEAD,MOB_PARA,MOB_BLIND,MOB_HIT, MOB_RUN};
//0:İ 1: 2: ¸ 3:ݸϴ¸ 4:ִ¸
enum {MOB_NORMAL,MOB_AGGRESSIVE, MOB_REGRESSIVE, MOB_CHICKEN, MOB_STATIONARY};
struct mobdb_data {
    int id;
	char name[32];
	char yname[32];
	int vita;
	int exp;
	int type;
	int look;
	int look_color;
	int attack;
	int dropitemcount;
	int drop_count[21];
	int drop[21];
	int drop_rate[21];
	int movetime;
	int spawntime;
	char sizetype; // Large or Small
	int ac;
	char *attack_script;
	char *attacked_script;
	char *move_script;
	char *die_script;
};


extern struct mobdb_data *mobdb[0xFFFF];
#define mobdb_search(id) mobdb[id]
#define mobdb_searchexist(id) mobdb[id]
#define mobdb_movetime(id) mobdb[id]->movetime
#define mobdb_spawntime(id)  mobdb[id]->spawntime
#define mobdb_exp(id) mobdb[id]->exp
#define mobdb_color(id) mobdb[id]->look_color
#define mobdb_getvita(id) mobdb[id]->vita
#define mobdb_look(id) mobdb[id]->look
#define mobdb_name(id) mobdb[id]->name
#define mobdb_itemrate(id, drop)  mobdb[id]->drop_rate[drop]
#define mobdb_itemid(id, dropn)  mobdb[id]->drop[dropn]
#define mobdb_itemamount(id, drop)  mobdb[id]->drop_count[drop]
#define mobdb_type(id)  mobdb[id]->type
#define mobdb_sizetype(id)  mobdb[id]->sizetype
#define mobdb_attack_script(id)  mobdb[id]->attack_script
#define mobdb_attacked_script(id)  mobdb[id]->attacked_script
#define mobdb_move_script(id)  mobdb[id]->move_script
#define mobdb_die_script(id)  mobdb[id]->die_script
#define mobdb_ac(id) mobdb[id]->ac
void mobdb_final();
int mobdb_read(const char *);
int mobspawn_read(const char *);
int mobdb_getspawntime(int);
int mobdb_init();
struct mobdb_data* mobdb_searchname(const char*);
int mobdb_searchname_sub(void*,void*,va_list);
int mob_handle(int,int);
int mob_handle_sub(struct mobspawn_data*);
int move_mob(struct mobspawn_data*);
int mobspawn_onetime(int,int,int,int);
int mobdb_drops(int,int,int,int);
int mob_respawn(struct mobspawn_data*);
int mob_find_target(struct block_list*,va_list);
int mob_move_intent(struct mobspawn_data*,struct map_sessiondata*);
int mob_move2(struct mobspawn_data*,int,int,int);
int mob_attack(struct mobspawn_data*,struct map_sessiondata*);
int mob_move(struct block_list*,va_list);
int mob_calc_damage( struct mobspawn_data *mob, struct map_sessiondata *sd ) ;
int mob_damaged( struct mobspawn_data *mob, int damage);
#endif