
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "../common/malloc.h"
#include "../common/nullpo.h"
#include "../common/db.h"
#include "../common/timer.h"
#include "../common/ers.h"
#include "map.h"
#include "npc.h"
#include "script.h"
#include "magic.h"
#include "itemdb.h"

struct npc_src_list {
	struct npc_src_list *next;
	char *file;
};

struct npc_code_list {
	struct npc_src_list *next;
	;
};
struct npc_src_list *npc_src_first = NULL;
struct npc_src_list *npc_src_last = NULL;
struct npc_shop_data *npc_shop[0xFFFF]={0,};

unsigned int npc_id = NPC_START_NUM;

#ifdef _WIN32
#undef isspace
#define isspace(x)  (x == ' ' || x == '\t')
#endif

//#define time_t long


static int npc_warp=0;
static int npc_shop_count=0;
static int npc_script=0;
static int npc_mob=0;
static int npc_delay_mob=0;
static int npc_cache_mob=0;
char *current_file = NULL;
int npc_get_new_npc_id(void){ return npc_id++; }

static struct dbt *ev_db;
static struct dbt *npcname_db;
static struct eri *timer_event_ers;
static struct tm ev_tm_b;	// vCxgp
struct event_data {
	struct npc_data *nd;
	int pos;
};

struct timer_event_data {
	int rid; //Attached player for this timer.
	int next; //timer index (starts with 0, then goes up to nd->u.scr.timeramount
	int time; //holds total time elapsed for the script since time 0 (whenthe timers started)
	unsigned int otick; //Holds tick value at which timer sequence was started (that is, it stores the tick value for which T= 0
};

// Function Prototype
//----------------------------
unsigned int npc_get_new_npcid();
int npc_parse_floor(char*,char*,char*,char*,char*,FILE*,int*,char*);
int npc_parse_script(char*,char*,char*,char*,char*,FILE*,int*,char*);
int npc_parse_shop(char*,char*,char*,char*,char*,FILE*,int*,char*);
static int npc_parse_function(char*,char*,char*,char*,char*,FILE*,int*,char*);
static void npc_parse_script_line(unsigned char*,int*,int line);
int npc_do_ontimer_sub(DBKey key,void *data,va_list ap);
int npc_event_do_sub(DBKey key,void *data,va_list ap);
int npc_event_doall_sub(DBKey key,void *data,va_list ap);
int npc_event_sub(struct map_sessiondata *sd, struct event_data *ev, const unsigned char *eventname);
int npc_convertlabel_db (DBKey key, void *data, va_list ap);
unsigned int npc_get_new_npcid() {
	return npc_id++;
}
int search_shopidcount(int shopid, int itemid) {
	int i;
	if(npc_shop[shopid] == NULL) {
		return -1;
	}
	for(i=0; i<npc_shop[shopid]->itemcount; i++) {
		if(npc_shop[shopid]->itemid[i] == itemid) {
			return i;
			break;
		}
	}
	return -1;
}
int npc_src_clear() {
	struct npc_src_list *p = npc_src_first;

	while(p) {
		struct npc_src_list *p2 = p;
		p = p->next;
		aFree(p2->file);
		aFree(p2);
	}
	npc_src_first = NULL;
	npc_src_last = NULL;
	return 0;
}

int npc_src_add(const char *file) {
	struct npc_src_list *new;

	CREATE(new, struct npc_src_list, 1);
	CREATE(new->file, char, strlen(file) + 1);
	new->next = NULL;
	strncpy(new->file, file, strlen(file));
	if (npc_src_first == NULL)
		npc_src_first = new;
	if (npc_src_last)
		npc_src_last->next = new;

	npc_src_last = new;
	return 0;
}
int npc_parse_script(char *w1,char *w2,char *w3,char *w4,char *first_line,FILE *fp,int *lines, const char *file) {
/*	int m,x,y;
	int opnpar=0;
	unsigned int new_id;
	char *srcbuf;
	struct script_code *script;
	char *srcopn;
	int srcsize=65536;
	char line[1024];
	struct npc_data *nd;
    int g,g_c;
    
	if (sscanf(r1,"%d,%d,%d,%d,%d",&m,&x,&y,&g,&g_c) != 5 && strcmpi(r2,"script")!=0) {
		printf("parse_error: bad npc script at line %d\n",*lines);
		return -1;
	}
    
    
        
	if (!map_isloaded(m))
		return 0;

	CREATE(srcbuf, char, srcsize);
	strcat(srcbuf, first_line);
	srcopn = srcbuf;
	while(1) {
		opnpar=0;
		if (strchr(srcopn,'{'))
			opnpar++;
		if (strchr(srcopn,'}'))
			opnpar--;
		if (opnpar<=0)
			break;
		fgets(line,sizeof(line),fp);
		(*lines)++;
		if (strlen(srcbuf)+strlen(line)+1>srcsize) {
			srcsize += 65536;
			RECREATE(srcbuf, char, srcsize);
			memset(srcbuf + (srcsize - 65536), 0, 65536);
		}
		strcat(srcbuf,line);
		if (feof(fp))
			break;
	}

	script=parse_script((unsigned char*)srcbuf,filename, *lines);
	aFree(srcbuf);
	if (script==NULL) {
		return -1;
	}

	new_id = npc_get_new_npcid();
	if (new_id >= NPC_START_NUM + MAX_NPC) {
		printf("MAP_ERR: Max NPC limit is reached.\n");
		return 0;
	}
	CREATE(nd, struct npc_data, 1);
	nd->bl.id = new_id;
	nd->bl.m = m;
	nd->bl.x = x;
	nd->bl.y = y;
	nd->bl.type = BL_NPC;
	nd->bl.subtype = SCRIPT;
	nd->bl.graphic_id=g;
	nd->bl.graphic_color=g_c;
    nd->bl.prev = NULL;
	nd->bl.next = NULL;
	nd->script = script;
	memcpy(nd->name, r3, 32);
	nd->name[31]='\0';
	map_addblock(&nd->bl);
	map_addiddb(&nd->bl);
	//printf("debug: %d\n",g);
	return 0;*/

	int x=0, y=0, dir = 0,  xs = 0, ys = 0, class_ = 0;	// [Valaris] thanks to fov
	short g=0,g_c=0;
	short m=0;
	unsigned char *srcbuf = NULL;
	struct script_code *script;
	int srcsize = 65536;
	int startline = 0;
	unsigned char line[1024];
	int i;
	struct npc_data *nd, *dnd;
	struct dbt *label_db;
	char *p;
	struct npc_label_list *label_dup = NULL;
	int label_dupnum = 0;
	int src_id = 0;

	if (strcmp(w1, "-") == 0) {
		x = 0; y = 0; m = -1;
	} else {
		// ̌`FbN
		if (sscanf(w1, "%d,%d,%d,%d,%d", &m, &x, &y, &g, &g_c) != 5 &&
			strcmp(w2, "script") != 0 ) {
			ShowError("bad script line (in file %s): %s\n", file, w3);
			return 1;
		}
	}

	

	if (strcmp(w2, "script") == 0){
		// parsing script with curly
		int curly_count = 0;
		srcbuf = (unsigned char *)aMallocA(srcsize*sizeof(char));
		if (strchr(first_line, '{')) {
			strcpy((char *)srcbuf, strchr(first_line, '{'));
			startline = *lines;
		} else
			srcbuf[0] = 0;
		npc_parse_script_line(srcbuf,&curly_count,*lines);
		while (curly_count > 0) {
			fgets ((char *)line, 1020, fp);
			(*lines)++;
			npc_parse_script_line(line,&curly_count,*lines);
			if (feof(fp))
				break;
			if (strlen((char *)srcbuf) + strlen((char *)line) + 1 >= (size_t)srcsize) {
				srcsize += 65536;
				srcbuf = (unsigned char *)aRealloc(srcbuf, srcsize);
				memset(srcbuf + srcsize - 65536, '\0', 65536);
			}
			if (srcbuf[0] != '{') {
				if (strchr((char *) line,'{')) {
					strcpy((char *) srcbuf, strchr((const char *) line, '{'));
					startline = *lines;
				}
			} else
				strcat((char *) srcbuf, (const char *) line);
		}
		if(curly_count > 0) {
			ShowError("Missing right curly at file %s, line %d\n",file, *lines);
			script = NULL;
		} else {
			// printf("Ok line %d\n",*lines);
			script = parse_script((unsigned char *) srcbuf, file, startline);
		}
		if (script == NULL) {
			// script parse error?
			aFree(srcbuf);
			return 1;
		}
	} else {
		// duplicate
		char srcname[128];
		struct npc_data *dnd;
		if (sscanf(w2, "duplicate(%[^)])", srcname) != 1) {
			ShowError("bad duplicate name (in %s)! : %s", file, w2);
			return 0;
		}
		if ((dnd = npc_name2id(srcname)) == NULL) {
			ShowError("bad duplicate name (in %s)! (not exist) : %s\n", file, srcname);
			return 0;
		}
		script = dnd->u.scr.script;
		label_dup = dnd->u.scr.label_list;
		label_dupnum = dnd->u.scr.label_list_num;
		src_id = dnd->bl.id;

	}// end of XNvg

	nd = (struct npc_data *)aCalloc(1, sizeof(struct npc_data));
/*
	if (sscanf(w4, "%d,%d,%d", &class_, &xs, &ys) == 3) {
		// ڐG^NPC
		int i, j;

		if (xs >= 0) xs = xs * 2 + 1;
		if (ys >= 0) ys = ys * 2 + 1;

		if (m >= 0) {
			for (i = 0; i < ys; i++) {
				for (j = 0; j < xs; j++) {
					if (map_getcell(m, x - xs/2 + j, y - ys/2 + i, CELL_CHKNOPASS))
						continue;
					map_setcell(m, x - xs/2 + j, y - ys/2 + i, CELL_SETNPC);
				}
			}
		}
		nd->u.scr.xs = xs;
		nd->u.scr.ys = ys;
	} else {
		// NbN^NPC
		class_ = atoi(w4);
		nd->u.scr.xs = 0;
		nd->u.scr.ys = 0;
	}
*/
	nd->u.scr.xs=0;
	nd->u.scr.ys=0;

	while ((p = strchr(w3,':'))) {
		if (p[1] == ':') break;
	}
	if (p) {
		*p = 0;
		memcpy(nd->name, w3, NAME_LENGTH-1);
		memcpy(nd->exname, p+2, NAME_LENGTH-1);
	} else {
		memcpy(nd->name, w3, NAME_LENGTH-1);
		memcpy(nd->exname, w3, NAME_LENGTH-1);
	}

	if((dnd = npc_name2id(nd->exname))){
//		if(battle_config.etc_log)
			ShowInfo("npc_parse_script: Overriding NPC '%s::%s' to '%s::%d'.. in file '%s' (Duplicated System Name - Lazy scripters >_>) \n",nd->name,nd->exname,nd->name,npc_script,file);
		sprintf(nd->exname, "%d", npc_script);
	}

	nd->bl.prev = nd->bl.next = NULL;
	nd->bl.m = m;
	nd->bl.x = x;
	nd->bl.y = y;
	nd->bl.id = npc_get_new_npc_id();
	nd->u.scr.script = script;
	nd->u.scr.src_id = src_id;
	nd->bl.graphic_id=g;
	nd->bl.graphic_color=g_c;
	npc_script++;
	nd->bl.type = BL_NPC;
	nd->bl.subtype = SCRIPT;


	map_addblock(&nd->bl);
	map_addiddb(&nd->bl);

	for (i = 0; i < MAX_EVENTTIMER; i++)
		nd->eventtimer[i] = -1;

	strdb_put(npcname_db, nd->exname, nd);

	//-----------------------------------------
	// xf[^̏
	if (srcbuf){
		// script{̂ꍇ̏
		// xf[^̃Ro[g
		label_db = script_get_label_db();
		label_db->foreach(label_db, npc_convertlabel_db, nd);

		// gȂ̂Ńobt@
		aFree(srcbuf);
	} else {
		// duplicate
		nd->u.scr.label_list = label_dup;	// xf[^L
		nd->u.scr.label_list_num = label_dupnum;
	}

	//-----------------------------------------
	// Cxgpxf[^̃GNX|[g
	for (i = 0; i < nd->u.scr.label_list_num; i++){
		char *lname = nd->u.scr.label_list[i].name;
		int pos = nd->u.scr.label_list[i].pos;

		if ((lname[0] == 'O' || lname[0] == 'o') && (lname[1] == 'N' || lname[1] == 'n')) {
			// this check is useless here because the buffer is only 24 chars
			// and already overwritten if this is here is reached
			// I leave the check anyway but place it correctly to npc_convertlabel_db
			if (strlen(lname)>NAME_LENGTH-1) {
				ShowError("npc_parse_script: label name longer than %d chars! '%s' (%s)\n", NAME_LENGTH-1, lname, file);
				exit(1);
			} else {
				struct event_data *ev;
				unsigned char buf[51];
				// 51 comes from: 24 for npc name + 24 for label + 2 for a "::" and 1 for EOS
				sprintf(buf,"%s::%s",nd->exname,lname);

				// remember the label is max 50 chars + eos; see the strdb_init below
				// generate the data and insert it
				ev=(struct event_data *)aMalloc(sizeof(struct event_data));
				ev->nd=nd;
				ev->pos=pos;
				if (strdb_put(ev_db,buf,ev) != NULL) //There was already another event of the same name?
					ShowWarning("npc_parse_script : duplicate event %s (%s)\n",buf, file);
			}
		}
	}

	//-----------------------------------------
	// xf[^^C}[Cxg荞
	for (i = 0; i < nd->u.scr.label_list_num; i++){
		int t = 0, k = 0;
		char *lname = nd->u.scr.label_list[i].name;
		int pos = nd->u.scr.label_list[i].pos;
		if (sscanf(lname, "OnTimer%d%n", &t, &k) == 1 && lname[k] == '\0') {
			// ^C}[Cxg
			struct npc_timerevent_list *te = nd->u.scr.timer_event;
			int j, k = nd->u.scr.timeramount;
			if (te == NULL)
				te = (struct npc_timerevent_list *)aMallocA(sizeof(struct npc_timerevent_list));
			else
				te = (struct npc_timerevent_list *)aRealloc( te, sizeof(struct npc_timerevent_list) * (k+1) );
			for (j = 0; j < k; j++){
				if (te[j].timer > t){
					memmove(te+j+1, te+j, sizeof(struct npc_timerevent_list)*(k-j));
					break;
				}
			}
			te[j].timer = t;
			te[j].pos = pos;
			nd->u.scr.timer_event = te;
			nd->u.scr.timeramount++;
		}
	}
	nd->u.scr.timerid = -1;

	return 0;
}
int npc_parse_floor(char *r1,char *r2,char *r3,char *r4,char *first_line,FILE *fp,int *lines, char *filename) {
	int m,x,y;
	int opnpar=0;
	unsigned int new_id;
	char *srcbuf;
	struct script_code *script;
	char *srcopn;
	int srcsize=65536;
	char line[1024];
	struct npc_data *nd;

	if (sscanf(r1,"%d,%d,%d",&m,&x,&y) != 3 && strcmpi(r2,"floor")!=0) {
		printf("parse_error: bad floor script at line %d\n",*lines);
		return -1;
	}

	if (!map_isloaded(m))
		return 0;

	CREATE(srcbuf, char, srcsize);
	strcat(srcbuf, first_line);
	srcopn = srcbuf;
	while(1) {
		opnpar=0;
		if (strchr(srcopn,'{'))
			opnpar++;
		if (strchr(srcopn,'}'))
			opnpar--;
		if (opnpar<=0)
			break;
		fgets(line,sizeof(line),fp);
		(*lines)++;
		if (strlen(srcbuf)+strlen(line)+1>srcsize) {
			srcsize += 65536;
			RECREATE(srcbuf, char, srcsize);
			memset(srcbuf + (srcsize - 65536), 0, 65536);
		}
		strcat(srcbuf,line);
		if (feof(fp))
			break;
	}

	script=parse_script((unsigned char*)srcbuf,filename, *lines);
	aFree(srcbuf);
	if (script==NULL) {
		return -1;
	}

	new_id = npc_get_new_npcid();
	if (new_id >= NPC_START_NUM + MAX_NPC) {
		printf("MAP_ERR: Max NPC limit is reached.\n");
		return 0;
	}
	CREATE(nd, struct npc_data, 1);
	nd->bl.id = new_id;
	nd->bl.m = m;
	nd->bl.x = x;
	nd->bl.y = y;
	nd->bl.type = BL_NPC;
	nd->bl.subtype = FLOOR;
	nd->bl.prev = NULL;
	nd->bl.next = NULL;
	nd->u.scr.script = script;
	nd->u.scr.src_id = new_id;
	memcpy(nd->name, r3, 32);
	nd->name[31]='\0';
	map_addblock(&nd->bl);
	map_addiddb(&nd->bl);
	return 0;
}

int npc_init_sub() {

	FILE *fp;
	char line[1024],r1[1024],r2[1024],r3[1024],r4[1024];
	int count,lines,r4pos;
	struct npc_src_list *i;
	int ret;
	
	npc_id = NPC_START_NUM;

	for(i=npc_src_first;i;i=i->next) {
		if ((fp=fopen(i->file,"r"))==NULL) {
			printf("NPC_ERR: NPC file not found (%s).\n",i->file);
			continue;
		}
		lines=0;
		while(fgets(line,sizeof(line),fp)) {
			lines++;

			if (line[0] == '/' && line[1] == '/')
				continue;

			if ((count=sscanf(line,"%[^\t]\t%[^\t]\t%[^\t\r\n]\t%n%[^\t\r\n]",r1,r2,r3,&r4pos,r4)) < 4 &&
				(count=sscanf(line,"%s%s%s%n%s",r1,r2,r3,&r4pos,r4)) < 4)
			{
				continue;
			}
			if (strcmpi(r2,"floor")==0) {
				if(ret=npc_parse_floor(r1,r2,r3,r4,line+r4pos,fp,&lines,i->file))
					printf("**parse_error file: %s %d\n", i->file, ret);
				
			}
			
			if (strcmpi(r2,"script")==0) {
               if(ret=npc_parse_script(r1,r2,r3,r4,line+r4pos,fp,&lines, i->file))
                    printf("**parse_error file: %s %d\n", i->file, ret);
             }
			
			if (strcmpi(r2,"shop")==0) {
				 if(ret=npc_parse_shop(r1,r2,r3,r4,line+r4pos,fp,&lines, i->file))
                    printf("**parse_error file: %s %d\n", i->file, ret);
			}
			if(strcmpi(r1,"function")==0){
				if(ret=npc_parse_function(r1,r2,r3,r4,line+r4pos,fp,&lines,i->file))
					printf("**parse_error file: %s %d\n",i->file, ret);
			}
		}
		fclose(fp);
	}
	//npc_src_clear();
	printf("Npc script read done. Total %d NPC read!\n", npc_id-NPC_START_NUM);
	return 0;
}

int npc_init() {

	// db init & allocate
	ev_db = db_alloc(__FILE__,__LINE__,DB_STRING,DB_OPT_DUP_KEY|DB_OPT_RELEASE_DATA,51);
	npcname_db = db_alloc(__FILE__,__LINE__,DB_STRING,DB_OPT_BASE,NAME_LENGTH);
	memset(&ev_tm_b, -1, sizeof(ev_tm_b));
	timer_event_ers = ers_new((uint32)sizeof(struct timer_event_data));

	npc_init_sub();
}

int npc_scriptcont(struct map_sessiondata *sd, int id, int pos) {
    nullpo_retr(1, sd);

	if (id!=sd->npc_id){
		ShowWarning("npc_scriptcont: sd->npc_id (%d) is not id (%d).\n", sd->npc_id, id);
		return 1;
	}
/*	
	if(id != fake_nd->bl.id) { // Not item script
		if ((npc_checknear(sd,map_id2bl(id))) == NULL){
			ShowWarning("npc_scriptcont: failed npc_checknear test.\n");
			return 1;
		}
	}
*/

	run_script_main(sd->st);

	return 0;
}
int npc_parse_shop(char *w1, char *w2, char *w3, char *w4, char *first_line, FILE *fp, int *lines ,char *filename)
{
	struct npc_shop_data * nsd;
	int shopid;
	char *p;
	int pos = 0;
	int count = 0;
	int itemid,bp,sp;
	CREATE(nsd,struct npc_shop_data, 1);
	shopid = atoi(w1);
	nsd->id = shopid;
	nsd->itemcount = 0;
	p = strchr(w3, ',');
	while (p && pos < 256) {
		p++;
		sscanf(p, "%d:%d:%d", &itemid, &bp, &sp);

		if(bp < 0) { // ǽ   
			bp = item_db[itemid]->price;
		}
		if(sp < 0) { // ǽ   
			sp = item_db[itemid]->price/2;
		}
		nsd->itemid[count] = itemid;
		nsd->buyprice[count] = bp;
		nsd->sellprice[count] = sp;
		if(nsd->buyprice[count]<nsd->sellprice[count]) {
			ShowWarning("Npc Shop: Ű ǸŰ  Ůϴ.shopid:[%d %d°]\n",shopid,count+1);
		}
		nsd->itemcount++;
		count++;
		pos++;
		p = strchr(p, ',');
	}
	npc_shop[npc_shop_count] = nsd;
	npc_shop_count++;
}
static int npc_parse_function (char *w1, char *w2, char *w3, char *w4, char *first_line, FILE *fp, int *lines ,char *filename)
{
	unsigned char *srcbuf, *script, *p;
	int srcsize = 65536;
	int startline = 0;
	char line[1024];
	int curly_count = 0;
	struct dbt *user_db;
	
	
	// XNvg̉
	CREATE(srcbuf,char,srcsize);
	if (strchr(first_line,'{')) {
		strcpy(srcbuf, strchr(first_line,'{'));
		startline = *lines;
	} else
		srcbuf[0] = 0;
	npc_parse_script_line(srcbuf,&curly_count,*lines);

	while (curly_count > 0) {
		fgets(line, sizeof(line) - 1, fp);
		(*lines)++;
		npc_parse_script_line(line,&curly_count,*lines);
		if (feof(fp))
			break;
		if (strlen(srcbuf)+strlen(line)+1 >= (unsigned int)srcsize) {
			srcsize += 65536;
			RECREATE(srcbuf, char, srcsize);
			memset(srcbuf + srcsize - 65536, '\0', 65536);
		}
		if (srcbuf[0]!='{') {
			if (strchr(line,'{')) {
				strcpy(srcbuf, strchr(line,'{'));
				startline = *lines;
			}
		} else
			strcat(srcbuf,line);
	}
	if(curly_count > 0) {
		//printf("Missing right curly at file %s, line %d\n",current_file, *lines);
		script = NULL;
	} else {
		script = parse_script(srcbuf,filename, startline);
	}
	if (script == NULL) {
		// script parse error?
		aFree(srcbuf);
		return 1;
	}

	CREATE(p,char,50);
	strncpy(p, w3, 50);
	
	user_db = script_get_userfunc_db();
	if(strdb_get(user_db, p) != NULL) {
		printf("\r"); //Carriage return to clear the 'loading..' line. [Skotlex]
		ShowWarning("parse_function: Duplicate user function [%s] (%s:%d)\n", p, filename, *lines);
		aFree(p);
		script_free_code(script);
	} else
		strdb_put(user_db, p, script);
	
	// gȂ̂Ńobt@
	aFree(srcbuf);
	
	//printf("function %s => %p\n",p,script);
	
	return 0;
}

static void npc_parse_script_line(unsigned char *p,int *curly_count,int line) {
	int i = strlen((char *)p),j;
	int string_flag = 0;
	static int comment_flag = 0;
	for(j = 0; j < i ; j++) {
		if(comment_flag) {
			if(p[j] == '*' && p[j+1] == '/') {
				// }`CRgI
				j++;
				(*curly_count)--;
				comment_flag = 0;
			}
		} else if(string_flag) {
			if(p[j] == '"') {
				string_flag = 0;
			} else if(p[j] == '\\' && p[j-1]<=0x7e) {
				// GXP[v
				j++;
			}
		} else {
			if(p[j] == '"') {
				string_flag = 1;
			} else if(p[j] == '}') {
				if(*curly_count == 0) {
					break;
				} else {
					(*curly_count)--;
				}
			} else if(p[j] == '{') {
				(*curly_count)++;
			} else if(p[j] == '/' && p[j+1] == '/') {
				// Rg
				break;
			} else if(p[j] == '/' && p[j+1] == '*') {
				// }`CRg
				j++;
				(*curly_count)++;
				comment_flag = 1;
			}
		}
	}
	if(string_flag) {
		//printf("Missing '\"' at file %s line %d\n",current_file,line);
		//exit(1);
	}
}

/*==========================================
 * CxgL[̃Cxg
 *------------------------------------------
 */
int npc_event_dequeue(struct map_sessiondata *sd)
{
	nullpo_retr(0, sd);

	if(sd->npc_id)
	{	//Current script is aborted.
		if (sd->st) {
			sd->st->pos = -1;
			script_free_stack(sd->st->stack);
			aFree(sd->st);
			sd->st = NULL;
		}
		sd->npc_id = 0;
	}

	if (!sd->eventqueue[0][0])
		return 0; //Nothing to dequeue

	if (!pc_addeventtimer(sd,100,sd->eventqueue[0]))
	{	//Failed to dequeue, couldn't set a timer.
		ShowWarning("npc_event_dequeue: event timer is full !\n");
		return 0;
	}
	//Event dequeued successfully, shift other elements.
	memmove(sd->eventqueue[0], sd->eventqueue[1], (MAX_EVENTQUEUE-1)*sizeof(sd->eventqueue[0]));
	sd->eventqueue[MAX_EVENTQUEUE-1][0]=0;
	return 1;
}

struct npc_data* npc_name2id(const char *name)
{
	return (struct npc_data *) strdb_get(npcname_db,(unsigned char*)name);
}

/*==========================================
 * ^C}[l̏
 *------------------------------------------
 */
int npc_gettimerevent_tick(struct npc_data *nd)
{
	int tick;
	nullpo_retr(0, nd);

	tick=nd->u.scr.timer;
	if (nd->u.scr.timertick)
		tick+=DIFF_TICK(gettick(), nd->u.scr.timertick);
	return tick;
}

int npc_do_ontimer(int npc_id, int option)
{
	ev_db->foreach(ev_db, npc_do_ontimer_sub, &npc_id, option);
	return 0;
}

int npc_do_ontimer_sub(DBKey key,void *data,va_list ap)
{
	unsigned char *p = key.str;
	struct event_data *ev = (struct event_data *)data;
	int *c = va_arg(ap,int *);
//	struct map_session_data *sd=va_arg(ap,struct map_session_data *);
	int option = va_arg(ap,int);
	int tick = 0;
	char temp[10];
	char event[50];

	if(ev->nd->bl.id == (int)*c && (p = strchr(p,':')) && strnicmp("::OnTimer",p,8) == 0){
		sscanf(&p[9], "%s", temp);
		tick = atoi(temp);

		strcpy(event, ev->nd->name);
		strcat(event, p);

		if (option!=0) {
			npc_addeventtimer(ev->nd, tick, event);
		} else {
			npc_deleventtimer(ev->nd, event);
		}
	}
	return 0;
}
int npc_addeventtimer(struct npc_data *nd,int tick,const char *name)
{
	int i;
	unsigned char *evname;
	
	for(i=0;i<MAX_EVENTTIMER;i++)
		if( nd->eventtimer[i]==-1 )
			break;
	if(i<MAX_EVENTTIMER){
		if (!strdb_get(ev_db,(unsigned char*)name)) {
		//	if (battle_config.error_log)
				ShowError("npc_addeventimer: Event %s does not exists.\n", name);
			return 1; //Event does not exists!
		}
		evname =(unsigned char *) aMallocA(NAME_LENGTH*sizeof(char));
		if(evname==NULL){
			ShowFatalError("npc_addeventtimer: out of memory !\n");exit(1);
		}
		memcpy(evname,name,NAME_LENGTH-1);
		evname[NAME_LENGTH-1] = '\0';
		nd->eventtimer[i]=add_timer(gettick()+tick,
			npc_event_timer,nd->bl.id,(int)evname);
	}else
		ShowWarning("npc_addtimer: event timer is full !\n");

	return 0;
}

int npc_deleventtimer(struct npc_data *nd,const unsigned char *name)
{
	int i;

	for(i=0;i<MAX_EVENTTIMER;i++) {

		if( nd->eventtimer[i]!=-1 && strcmp(get_timer(nd->eventtimer[i])->data, name)==0 ){
				delete_timer(nd->eventtimer[i],npc_event_timer);
				nd->eventtimer[i]=-1;
				break;
		}
	}

	return 0;
}

int npc_timerevent_stop(struct npc_data *nd)
{
	struct map_sessiondata *sd =NULL;
	struct TimerData *td = NULL;
	int *tid;
	nullpo_retr(0, nd);
	if (nd->u.scr.rid) {
		sd = map_id2sd(nd->u.scr.rid);
		if (!sd) {
	//		if(battle_config.error_log)
				ShowError("npc_timerevent_stop: Attached player not found!\n");
			return 1;
		}
	}
	
	tid = sd?&sd->npc_timer_id:&nd->u.scr.timerid;
	
	if (*tid == -1) //Nothing to stop
		return 0;
	td = get_timer(*tid);
	if (td && td->data) 
		ers_free(timer_event_ers, (struct event_timer_data*)td->data);
	delete_timer(*tid,npc_timerevent);
	*tid = -1;
	//Set the timer tick to the time that has passed since the beginning of the timers and now.
	nd->u.scr.timer = DIFF_TICK(gettick(),nd->u.scr.timertick);
//	nd->u.scr.rid = 0; //Eh? why detach?
	return 0;
}

int npc_cleareventtimer(struct npc_data *nd)
{
	int i;
	for(i=0;i<MAX_EVENTTIMER;i++)
		if( nd->eventtimer[i]!=-1 ){
			delete_timer(nd->eventtimer[i],npc_event_timer);
			nd->eventtimer[i]=-1;
		}

	return 0;
}

/*==========================================
 * Cxg̒xs
 *------------------------------------------
 */
int npc_event_timer(int tid,unsigned int tick,int id,int data)
{
	unsigned char *eventname = (unsigned char *)data;
	struct event_data *ev = strdb_get(ev_db,eventname);
	struct npc_data *nd;
	struct map_sessiondata *sd=map_id2sd(id);
	size_t i;

	if((ev==NULL || (nd=ev->nd)==NULL))
	{
	//	if(battle_config.error_log)
			ShowWarning("npc_event: event not found [%s]\n",eventname);
	}
	else
	{
		for(i=0;i<MAX_EVENTTIMER;i++) {
			if( nd->eventtimer[i]==tid ) {
				nd->eventtimer[i]=-1;
				npc_event(sd,eventname,0); // sd NULL check is within
				break;
			}
		}
		if(i==MAX_EVENTTIMER /*&& battle_config.error_log*/)
			ShowWarning("npc_event_timer: event timer not found [%s]!\n",eventname);
	}

	aFree(eventname);
	return 0;
}

int npc_timer_event(const unsigned char *eventname)	// Added by RoVeRT
{
	struct event_data *ev=strdb_get(ev_db,(unsigned char*)eventname);
	struct npc_data *nd;
//	int xs,ys;

	if((ev==NULL || (nd=ev->nd)==NULL)){
		ShowWarning("npc_timer_event: event not found [%s]\n",eventname);
		return 0;
	}

	run_script(nd->u.scr.script,ev->pos,nd->bl.id,nd->bl.id);

	return 0;
}
int npc_event (struct map_sessiondata *sd, const unsigned char *eventname, int mob_kill)
{
	struct event_data *ev=strdb_get(ev_db,(unsigned char*)eventname);
	struct npc_data *nd;
	int xs,ys;
	unsigned char mobevent[100];

	if (sd == NULL) {
		nullpo_info(NLP_MARK);
		return 0;
	}

	if (ev == NULL && eventname && strcmp(((eventname)+strlen(eventname)-9),"::OnTouch") == 0)
		return 1;

	if (ev == NULL || (nd = ev->nd) == NULL) {
		if (mob_kill) {
			strcpy( mobevent, eventname);
			strcat( mobevent, "::OnMyMobDead");
			ev = strdb_get(ev_db, mobevent);
			if (ev == NULL || (nd = ev->nd) == NULL) {
				if (strnicmp(eventname, "GM_MONSTER",10) != 0)
					ShowError("npc_event: (mob_kill) event not found [%s]\n", mobevent);
				return 0;
			}
		} else {
//			if (battle_config.error_log)
				ShowError("npc_event: event not found [%s]\n", eventname);
			return 0;
		}
	}

	xs=nd->u.scr.xs;
	ys=nd->u.scr.ys;
	if (xs>=0 && ys>=0 && (strcmp(((eventname)+strlen(eventname)-6),"Global") != 0) )
	{
		if (nd->bl.m >= 0) { //Non-invisible npc
		  	if (nd->bl.m != sd->bl.m )
				return 1;
			if ( xs>0 && (sd->bl.x<nd->bl.x-xs/2 || nd->bl.x+xs/2<sd->bl.x) )
				return 1;
			if ( ys>0 && (sd->bl.y<nd->bl.y-ys/2 || nd->bl.y+ys/2<sd->bl.y) )
				return 1;
		}
	}
	
	return npc_event_sub(sd,ev,eventname);
}


/*==========================================
 * ^C}[l̐ݒ
 *------------------------------------------
 */
int npc_settimerevent_tick(struct npc_data *nd,int newtimer)
{
	int flag;
	struct map_sessiondata *sd=NULL;

	nullpo_retr(0, nd);

	if (nd->u.scr.rid) {
		sd = map_id2sd(nd->u.scr.rid);
		if (!sd) {
//			if(battle_config.error_log)
				ShowError("npc_settimerevent_tick: Attached player not found!\n");
			return 1;
		}
		flag= sd->npc_timer_id != -1 ;
	} else
		flag= nd->u.scr.timerid != -1 ;

	if(flag)
		npc_timerevent_stop(nd);
	nd->u.scr.timer=newtimer;
	if(flag)
		npc_timerevent_start(nd, -1);
	return 0;
}


int npc_event_do(const unsigned char *name)
{
	int c=0;

	if (*name==':' && name[1]==':') {
		return npc_event_doall(name+2);
	}

	ev_db->foreach(ev_db,npc_event_do_sub,&c,name);
	return c;
}

int npc_event_do_sub(DBKey key,void *data,va_list ap)
{
	unsigned char *p = key.str;
	struct event_data *ev;
	int *c;
	const unsigned char *name;

	nullpo_retr(0, ev=(struct event_data *)data);
	nullpo_retr(0, ap);
	nullpo_retr(0, c=va_arg(ap,int *));

	name=va_arg(ap,const unsigned char *);

	if (p && strcmpi(name,p)==0 ) {
		run_script(ev->nd->u.scr.script,ev->pos,0,ev->nd->bl.id);
		(*c)++;
	}

	return 0;
}

/*==========================================
 * vCxgs
 *------------------------------------------
 */
int npc_event_do_clock(int tid,unsigned int tick,int id,int data)
{
	time_t timer;
	struct tm *t;
	char buf[64];
        char *day="";
	int c=0;

	time(&timer);
	t=localtime(&timer);

        switch (t->tm_wday) {
	case 0: day = "Sun"; break;
	case 1: day = "Mon"; break;
	case 2: day = "Tue"; break;
	case 3: day = "Wed"; break;
	case 4: day = "Thu"; break;
	case 5: day = "Fri"; break;
	case 6: day = "Sat"; break;
	}

	if (t->tm_min != ev_tm_b.tm_min ) {
		sprintf(buf,"OnMinute%02d",t->tm_min);
		c+=npc_event_doall(buf);
		sprintf(buf,"OnClock%02d%02d",t->tm_hour,t->tm_min);
		c+=npc_event_doall(buf);
		sprintf(buf,"On%s%02d%02d",day,t->tm_hour,t->tm_min);
		c+=npc_event_doall(buf);
	}
	if (t->tm_hour!= ev_tm_b.tm_hour) {
		sprintf(buf,"OnHour%02d",t->tm_hour);
		c+=npc_event_doall(buf);
	}
	if (t->tm_mday!= ev_tm_b.tm_mday) {
		sprintf(buf,"OnDay%02d%02d",t->tm_mon+1,t->tm_mday);
		c+=npc_event_doall(buf);
	}
	memcpy(&ev_tm_b,t,sizeof(ev_tm_b));
	return c;
}
/*==========================================
 * OnInitCxgs(&vCxgJn)
 *------------------------------------------
 */
int npc_event_do_oninit(void)
{
//	int c = npc_event_doall("OnInit");
//	ShowStatus("Event '"CL_WHITE"OnInit"CL_RESET"' executed with '"CL_WHITE"%d"CL_RESET"' NPCs.\n",npc_event_doall("OnInit"));

	add_timer_interval(gettick()+100,
		npc_event_do_clock,0,0,1000);

	return 0;
}

int npc_timerevent(int tid,unsigned int tick,int id,int data)
{
	int next,t,old_rid,old_timer;
	unsigned int old_tick;
	struct npc_data* nd=(struct npc_data *)map_id2bl(id);
	struct npc_timerevent_list *te;
	struct timer_event_data *ted = (struct timer_event_data*)data;
	struct map_sessiondata *sd=NULL;
	
	if( nd==NULL ){
		ShowError("npc_timerevent: NPC not found??\n");
		return 0;
	}
	if (ted->rid) {
		sd = map_id2sd(ted->rid);
		if (!sd) {
//			if(battle_config.error_log)
				ShowError("npc_timerevent: Attached player not found.\n");
			ers_free(timer_event_ers, ted);
			return 0;
		}
	}
	old_rid = nd->u.scr.rid; //To restore it later.
	nd->u.scr.rid = sd?sd->bl.id:0;
	
	old_tick = nd->u.scr.timertick;
	nd->u.scr.timertick=ted->otick;
	te=nd->u.scr.timer_event+ ted->next;
	
	old_timer = nd->u.scr.timer;
	t = nd->u.scr.timer=ted->time;
	ted->next++;
	
	if( nd->u.scr.timeramount> ted->next){
		next= nd->u.scr.timer_event[ ted->next ].timer
			- nd->u.scr.timer_event[ ted->next-1 ].timer;
		ted->time+=next;
		if (sd)
			sd->npc_timer_id = add_timer(tick+next,npc_timerevent,id,(int)ted);
		else
			nd->u.scr.timerid = add_timer(tick+next,npc_timerevent,id,(int)ted);
	} else {
		if (sd)
			sd->npc_timer_id = -1;
		else
			nd->u.scr.timerid = -1;
		ers_free(timer_event_ers, ted);
	}
	run_script(nd->u.scr.script,te->pos,nd->u.scr.rid,nd->bl.id);
	//Restore previous data, only if this timer is a player-attached one.
	if (sd) {
		nd->u.scr.rid = old_rid;
		nd->u.scr.timer = old_timer;
		nd->u.scr.timertick = old_tick;
	}
	return 0;
}

int npc_event_doall(const unsigned char *name)
{
	int c=0;
	unsigned char buf[64]="::";

	strncpy(buf+2,name,62);
	ev_db->foreach(ev_db,npc_event_doall_sub,&c,buf,0);
	return c;
}

int npc_event_doall_sub(DBKey key,void *data,va_list ap)
{
	unsigned char*p = key.str;
	struct event_data *ev;
	int *c;
	int rid;
	unsigned char *name;

	ev=(struct event_data *)data;
	c=va_arg(ap,int *);
	name=va_arg(ap,unsigned char *);
	rid=va_arg(ap, int);

	if( (p=strchr(p,':')) && p && strcmpi(name,p)==0 ){
		if(rid)
			npc_event_sub(((struct map_sessiondata *)map_id2bl(rid)),ev,key.str);
		else
			run_script(ev->nd->u.scr.script,ev->pos,rid,ev->nd->bl.id);
		(*c)++;
	}

	return 0;
}

int npc_event_doall_id(const unsigned char *name, int rid)
{
	int c=0;
	unsigned char buf[64]="::";

	strncpy(buf+2,name,62);
	ev_db->foreach(ev_db,npc_event_doall_sub,&c,buf,rid);
	return c;
}
int npc_event_sub(struct map_sessiondata *sd, struct event_data *ev, const unsigned char *eventname){

	if ( sd->npc_id!=0) {
		//Enqueue the event trigger.
		int i;
		for(i=0;i<MAX_EVENTQUEUE && sd->eventqueue[i][0];i++);
		
		if (i==MAX_EVENTQUEUE) {
		//	if (battle_config.error_log)
			ShowWarning("npc_event: event queue is full !\n");
		} else //Event enqueued.
			memcpy(sd->eventqueue[i],eventname,50);
		return 1;
	}
	
	run_script(ev->nd->u.scr.script,ev->pos,sd->bl.id,ev->nd->bl.id);
	return 0;
}

int npc_timerevent_import(char *lname,void *data,va_list ap)
{
	int pos=(int)data;
	struct npc_data *nd=va_arg(ap,struct npc_data *);
	int t=0,i=0;

	if(sscanf(lname,"OnTimer%d%n",&t,&i)==1 && lname[i]==':') {
		// ^C}[Cxg
		struct npc_timerevent_list *te=nd->u.scr.timer_event;
		int j,i=nd->u.scr.timeramount;
		if(te==NULL) te=(struct npc_timerevent_list*)aMallocA(sizeof(struct npc_timerevent_list));
		else te= (struct npc_timerevent_list*)aRealloc( te, sizeof(struct npc_timerevent_list) * (i+1) );
		if(te==NULL){
			ShowFatalError("npc_timerevent_import: out of memory !\n");
			exit(1);
		}
		for(j=0;j<i;j++){
			if(te[j].timer>t){
				memmove(te+j+1,te+j,sizeof(struct npc_timerevent_list)*(i-j));
				break;
			}
		}
		te[j].timer=t;
		te[j].pos=pos;
		nd->u.scr.timer_event=te;
		nd->u.scr.timeramount++;
	}
	return 0;
}

int npc_timerevent_start(struct npc_data *nd, int rid)
{
	int j,n, next;
	struct map_sessiondata *sd=NULL; //Player to whom script is attached.
	struct timer_event_data *ted;
		
	nullpo_retr(0, nd);

	n=nd->u.scr.timeramount;
	if( n==0 )
		return 0;

	for(j=0;j<n;j++){
		if( nd->u.scr.timer_event[j].timer > nd->u.scr.timer )
			break;
	}
	if(j>=n) // check if there is a timer to use !!BEFORE!! you write stuff to the structures [Shinomori]
		return 0;
	if (nd->u.scr.rid > 0) {
		//Try to attach timer to this player.
		sd = map_id2sd(nd->u.scr.rid);
		if (!sd) {
	//		if(battle_config.error_log)
				ShowError("npc_timerevent_start: Attached player not found!\n");
			return 1;
		}
	}
	//Check if timer is already started.
	if (sd) {
		if (sd->npc_timer_id != -1)
			return 0;
	} else if (nd->u.scr.timerid != -1)
		return 0;
		
	ted = ers_alloc(timer_event_ers, struct timer_event_data);
	ted->next = j;
	nd->u.scr.timertick=ted->otick=gettick();

	//Attach only the player if attachplayerrid was used.
	ted->rid = sd?sd->bl.id:0;

// Do not store it to make way to two types of timers: globals and personals.	
//	if (rid >= 0) nd->u.scr.rid=rid;	// changed to: attaching to given rid by default [Shinomori]
	// if rid is less than 0 leave it unchanged [celest]

	next = nd->u.scr.timer_event[j].timer - nd->u.scr.timer;
	ted->time = nd->u.scr.timer_event[j].timer;
	if (sd)
		sd->npc_timer_id = add_timer(gettick()+next,npc_timerevent,nd->bl.id,(int)ted);
	else
		nd->u.scr.timerid = add_timer(gettick()+next,npc_timerevent,nd->bl.id,(int)ted);
	return 0;
}

/*==========================================
 * Aborts a running npc timer that is attached to a player.
 *------------------------------------------
 */
void npc_timerevent_quit(struct map_sessiondata *sd) {
	struct TimerData *td;
	if (sd->npc_timer_id == -1)
		return;
	td = get_timer(sd->npc_timer_id);
	if (!td) {
		sd->npc_timer_id = -1;
		return; //??
	}
	delete_timer(sd->npc_timer_id,npc_timerevent);
	sd->npc_timer_id = -1;
	ers_free(timer_event_ers, (struct event_timer_data*)td->data);
}

int npc_convertlabel_db (DBKey key, void *data, va_list ap)
{
	unsigned char *lname = key.str;
	int pos = (int)data;
	struct npc_data *nd;
	struct npc_label_list *lst;
	int num;
	char *p;
	char c;

	nullpo_retr(0, ap);
	nullpo_retr(0, nd = va_arg(ap,struct npc_data *));

	lst = nd->u.scr.label_list;
	num = nd->u.scr.label_list_num;
	if (!lst) {
		lst = (struct npc_label_list *) aCallocA (1, sizeof(struct npc_label_list));
		num = 0;
	} else
		lst = (struct npc_label_list *) aRealloc (lst, sizeof(struct npc_label_list)*(num+1));

	// In case of labels not terminated with ':', for user defined function support
	p = lname;
	while(isalnum(*(unsigned char*)p) || *p == '_') { p++; }
	c = *p;
	*p='\0';

	// here we check if the label fit into the buffer
	if (strlen(lname) > 23) {
		ShowError("npc_parse_script: label name longer than 23 chars! '%s'\n (%s)", lname, current_file);
		exit(1);
	}
	memcpy(lst[num].name, lname, strlen(lname)+1); //including EOS

	*p = c;
	lst[num].pos = pos;
	nd->u.scr.label_list = lst;
	nd->u.scr.label_list_num = num+1;

	return 0;
}

static int npc_unload_ev(DBKey key,void *data,va_list ap) {
	struct event_data *ev=(struct event_data *)data;
	unsigned char *npcname=va_arg(ap,unsigned char *);

	if(strcmp(ev->nd->exname,npcname)==0){
		db_remove(ev_db, key);
		return 1;
	}
	return 0;
}

int npc_unload (struct npc_data *nd)
{
	nullpo_ret(nd);


	map_deliddb(&nd->bl);


	if (nd->bl.subtype == SCRIPT) {
		ev_db->foreach(ev_db,npc_unload_ev,nd->exname); //Clean up all events related.
		if (nd->u.scr.timerid != -1) {
			struct TimerData *td = NULL;
			td = get_timer(nd->u.scr.timerid);
			if (td && td->data) 
				ers_free(timer_event_ers, (struct event_timer_data*)td->data);
			delete_timer(nd->u.scr.timerid, npc_timerevent);
		}
		npc_cleareventtimer (nd);
		if (nd->u.scr.timer_event)
			aFree(nd->u.scr.timer_event);
		if (nd->u.scr.src_id == 0) {
			if(nd->u.scr.script) {
				script_free_code(nd->u.scr.script);
				nd->u.scr.script = NULL;
			}
			if (nd->u.scr.label_list) {
				aFree(nd->u.scr.label_list);
				nd->u.scr.label_list = NULL;
			}
		}
	}
	aFree(nd);

	return 0;
}
int npc_final() {
	struct block_list *bl;
	int i;
	for (i = NPC_START_NUM; i < npc_id; i++){
		if ((bl = map_id2bl(i))){
			if (bl->type == BL_NPC)
				npc_unload((struct npc_data *)bl);
		}
	}
	ev_db->destroy(ev_db, NULL);
	npcname_db->destroy(npcname_db, NULL);
	ers_destroy(timer_event_ers);
}