
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "map.h"
#include "../common/mmo.h"
#include "../common/malloc.h"
#include "script.h"
#include "clif.h"
#include "itemdb.h"
#include "pc.h"
#include "../common/timer.h"
#include "../common/nullpo.h"
#include "magic.h"
#include "class_db.h"
int pc_isequip(struct map_sessiondata *sd,int type){
	return sd->status.equip[type].id;
}

void pc_chkinvalid_pos( struct map_sessiondata *sd) {
	if( map[sd->bl.m].xs==0 || 
		map[sd->bl.m].ys==0 ||
		map[sd->bl.m].xs < sd->bl.x ||
		map[sd->bl.m].ys < sd->bl.y ||
		sd->bl.x < 0 ||
		sd->bl.y < 0) {
		sd->bl.m = 0;
		sd->bl.x = 10;
		sd->bl.y = 11;
		// go to the nagnang's room 
		//-------------------------
	}
}
int pc_loadmagic(struct map_sessiondata *sd) {
	int i;
	
	for(i=0;i<26;i++) {
		if(sd->status.skill[i]>0) {
			clif_sendmagic(sd,i);
		}
	}
	return 0;
}
int pc_starttimer(struct map_sessiondata *sd) {
	
	sd->timer=add_timer_interval(gettick()+250,pc_timer,sd->bl.id,0,250);
	sd->regentimer=add_timer_interval(gettick()+25000,pc_regen,sd->bl.id,0,25000);
	return 0;
}
int pc_stoptimer(struct map_sessiondata *sd) {
	delete_timer(sd->timer,pc_timer);
	delete_timer(sd->regentimer,pc_regen);
	return 0;
}
int pc_magic_startup(struct map_sessiondata *sd) {
	int x;
	for(x=0;x<50;x++) {
		if(sd->status.dura_aether[x].id>0) {
			
			if(sd->status.dura_aether[x].duration>0){
				clif_send_duration(sd,sd->status.dura_aether[x].id,sd->status.dura_aether[x].duration/1000);
				sd->target=sd->status.id;
				run_script(magicdb_script3(sd->status.dura_aether[x].id),0,sd->bl.id,0);
			}
			if(sd->status.dura_aether[x].aether>0) {
				clif_send_aether(sd,sd->status.dura_aether[x].id,sd->status.dura_aether[x].aether/1000);
			
			}
		}
	}
	return 0;
}

int pc_dcrs_itemdura(struct map_sessiondata *sd, int id) {
	if(!sd->status.inventory[id].id) return 0;
	sd->status.inventory->dura--;
	
	if(sd->status.inventory->dura==0) {
		memset(&sd->status.inventory[id],0,sizeof(struct item));
		clif_senddelitem(sd,id,6);
		return 0;
	} else {
		clif_sendadditem(sd, id);
	}
}

struct map_sessiondata *tid2sd(int tid) {
	struct TimerData *td=get_timer(tid);
	if(td==NULL) {
		return NULL;
	} else {
		return map_id2sd(td->id);
	}
	
};

int pc_timer(int a,int b,int id,int c) {
	struct map_sessiondata *sd;
	int x;
	sd=map_id2sd(id);
	
	for(x=0;x<50;x++) {
		if(sd->status.dura_aether[x].id>0) {
			if(sd->status.dura_aether[x].aether>0) {
				sd->status.dura_aether[x].aether-=250;
			}
			if(sd->status.dura_aether[x].duration>0) {
				sd->status.dura_aether[x].duration-=250;
			}
			if(sd->status.dura_aether[x].duration<=0) {
				sd->target=sd->bl.id;
				run_script(magicdb_script2(sd->status.dura_aether[x].id),0,sd->bl.id,0);
			}
			
			if(sd->status.dura_aether[x].duration<=0 && sd->status.dura_aether[x].aether<=0){
				sd->status.dura_aether[x].duration=0;
				sd->status.dura_aether[x].aether=0;
				sd->status.dura_aether[x].id=0;
			}
			
		}
	}
	return 0;
}

int pc_regen(int a, int b, int id,int none) {
	struct map_sessiondata *sd;
	float rate;
	int hp;
	sd=map_id2sd(id);
	hp=sd->status.hp;
	rate=(float)((float)sd->max_hp*0.2);
	sd->status.hp+=rate;
	if (sd->status.hp>sd->max_hp) sd->status.hp=sd->max_hp;
	if(sd->status.hp!=hp) clif_sendstatus(sd);
	return 0;
}
int pc_checklevel(struct map_sessiondata *sd) {
	int a;
	int path;
	int oldlevel;
	if(sd->status.level==99) return 0;
	if(sd->status.level==5 && sd->status.class==0) return 0;
	path=sd->status.class;


	oldlevel=sd->status.level;
//	printf("%d, %d\n",exp_require[sd->status.class][sd->status.level+1] ,sd->status.exp);
	while (exp_require[sd->status.class][sd->status.level+1] <= sd->status.exp) {
		sd->status.level++;
		
		switch(sd->status.class) {
		case 0: // 
			a=rand()%11;
			sd->status.basehp+=45+a;
			a=rand()%11;
			sd->status.basehp+=30+a;
			if(sd->status.level%2) {
				sd->status.basewill++;
				sd->status.basegrace++;
			} else {
				sd->status.basemight++;
			}
			break;
		case 1: // 
			
				/*  2  1
				 1  1
				 3  1
			*/
			a=rand()%11;
			sd->status.basehp+=55+a;
			a=rand()%11;
			sd->status.basemp+=20+a;
			sd->status.basewill++;
			if(sd->status.level%2 == 0) {
				sd->status.basemight++;
			} else if(sd->status.level%3 == 0) {
				sd->status.basegrace++;
			}
			/*
			 
			5: 252,171 (5,5,5)
			6: 315,195 (6,6,6) 63 24	1 1 1
			7: 377,221(6,7,6)  62 26	0 1 0
			8: 434/246(7,8,6)  67 25	1 1 0
			9: 492/271(7,9,7)  58 25	0 1 1
			10: 552,295(8,10,7) 60 24	1 1 0
			
			5 256,173(5,5,5)
			6 335,182(6,6,6) 79 9	1 1 1
			7 416,190(7,6,6) 81 8	1 0 0
			8 493,198(8,7,6) 77 8	1 1 0
			9 565,206(9,7,7) 72 8	1 0 1
			10 638,214(10,8,7) 73 8 1 1 0
			/ȳ
			--ּ--
			5: 258,174(5,5,5)
			6: 299,216(6,6,6) 41 42		1 1 1
			7: 341,260(6,6,7) 42 44		0 0 1
			8: 382,302(6,7,8) 41 42		0 1 1
			9: 427,343(7,7,9) 45 41		1 0 1
			10: 469,384(7,8,10) 42 41	0 1 1
			11: 509,425(7,8,11) 40 41	0 0 1
			
			  ----
			  5: 257,168(5,5,5) 
			  6: 305,203(6,6,6) 48 35		1 1 1
			  7: 356,238(6,6,7) 51 35		0 0 1
			  8: 408,272(6,6,8) 52 34		0 0 1
			  9: 459,306(7,7,9) 51 34		1 1 1
			  10: 510,340(7,7,10) 51 36	0 0 1
			*/
		case 2: // 
			a=rand()%15;
			sd->status.basehp+=70+a;
			a=rand()%2;
			sd->status.basemp+=8+a;
			sd->status.basemight++;
			if(sd->status.level%2 == 0) {
				sd->status.basewill++;
			} else if(sd->status.level%3 == 0) {
				sd->status.basegrace++;
			}
			
			break;
		case 3: // ּ
			a=rand()%11;
			sd->status.basehp+=35+a;
			a=rand()%10;
			sd->status.basemp+=35+a;
			sd->status.basegrace++;
			if(sd->status.level%2 == 0) {
				sd->status.basewill++;
			} else if(sd->status.level%3 == 0) {
				sd->status.basemight++;
			}
			break;
		case 4: // 
			a=rand()%11;
			sd->status.basehp+=45+a;
			a=rand()%11;
			sd->status.basemp+=30+a;
			sd->status.basegrace++;
			if(sd->status.level%3==0) {
				sd->status.basewill++;
				sd->status.basemight++;
			}
			break;
		default: //may be others?
			
			break;
		}

		if(sd->status.level==5) {
			break;
		}
		
	}
	if(oldlevel!=sd->status.level) {
		
		pc_calcstat(sd);
		pc_heal(sd,sd->max_hp,sd->max_mp);
		clif_sendstatus(sd);	
		map_foreachinarea(clif_sendanimation,sd->bl.m,sd->bl.x,sd->bl.y,AREA,BL_PC,2,&sd->bl);
		
	}
	return 0;
}	
int pc_givexp(struct map_sessiondata *sd, int exp, int xprate) {
	//int xp_rate=1;
	unsigned int totalxp;
	unsigned int defaultxp;
	unsigned char xpstring[256];
	int len;

	if(sd->status.level == 5 && sd->status.class==0) {
		clif_sendminitext(sd,map_msg[MAP_HASTO_CLASS].message,map_msg[MAP_HASTO_CLASS].len);
		return 0;
	}
	if(exp<0) {
		if(sd->status.exp<abs(exp)) { 
			sd->status.exp=0;
		} else {
			sd->status.exp=sd->status.exp+exp;
		}
		clif_sendstatus(sd);
		
		return 0;
	}


	defaultxp=(unsigned int)4294967295-totalxp;
	totalxp=exp*xprate;
	
	

	sd->status.exp=sd->status.exp + totalxp;
	if(sd->status.exp < totalxp) {
		sd->status.exp-=totalxp;
		clif_sendminitext(sd,map_msg[MAP_GETEXP].message,map_msg[MAP_GETEXP].len);
	} else {
		len=sprintf(xpstring,map_msg[MAP_GETEXP].message,totalxp);
		pc_checklevel(sd);
		clif_sendminitext(sd,xpstring,len);
		clif_sendstatus(sd);
	}
	
	
	return 0;
}

unsigned int pc_calcstat_per( unsigned int point, int per, int *dummy) {
	unsigned int buf;
	if(per==0) return point;
	buf=point/per;
	*dummy+=buf;
	return buf;
}
int pc_calcstat(struct map_sessiondata *sd) {
	int x;
	int id;
	sd->dam=0;
	sd->hit=0;
	sd->max_hp = sd->status.basehp;
	sd->max_mp = sd->status.basemp;
	sd->might = sd->status.basemight;
	sd->will = sd->status.basewill;
	sd->grace = sd->status.basegrace;
	sd->ac=99-sd->status.level;
	sd->max_dam_l=0;
	sd->min_dam_l=0;
	sd->max_dam_s=0;
	sd->min_dam_s=0;
	sd->protection=0;
	


	for(x=0;x<9;x++) {
		id=sd->status.equip[x].id;
		if(id>0) {
			
			// special ability item that increase points as percent [Lene]
			sd->status.eqvitaup[x]= pc_calcstat_per(sd->status.basehp, itemdb_vita_per(id), &sd->max_hp);
			sd->status.eqmanaup[x]= pc_calcstat_per(sd->status.basemp, itemdb_mana_per(id), &sd->max_mp);

			sd->max_hp+=itemdb_vita(id);
			sd->max_mp+=itemdb_mana(id);
			sd->ac+=itemdb_ac(id);
			sd->dam+=itemdb_dam(id);
			sd->hit+=itemdb_hit(id);
			sd->min_dam_l+=itemdb_mindam_l(id);
			sd->max_dam_l+=itemdb_maxdam_l(id);
			sd->min_dam_s+=itemdb_mindam_s(id);
			sd->max_dam_s+=itemdb_maxdam_s(id);
			sd->protection+=itemdb_protection(id);
			sd->status.might+=itemdb_might_up(id);
			sd->status.might+=itemdb_will_up(id);
			sd->status.might+=itemdb_grace_up(id);
		}
	}
	
	
	if (sd->status.hp>sd->max_hp)
		sd->status.hp = sd->max_hp;
	if (sd->status.mp>sd->max_mp)
		sd->status.mp = sd->max_mp;
	clif_sendstatus(sd);
	return 0;
	
}
int pc_calcdamage(struct map_sessiondata *sd, int type) {
	int damage=0;
	int ran;
	int min_dam= (type == 'l')? sd->min_dam_l:sd->min_dam_s;
	int max_dam= (type == 'l')? sd->max_dam_l:sd->max_dam_s;
	damage+=(sd->status.might/5);
	if(damage==0) damage=1;
	damage=damage+(pc_calcdam(sd)*5);
	if(min_dam>0 && max_dam>0){
	ran=max_dam-min_dam;
	ran=rand()%ran;
	ran=ran+min_dam;
	ran=ran/2;
	damage+=ran;
	}
	return damage;
}
int pc_calcdam(struct map_sessiondata *sd) {
	int dam=1;
	
	return dam;
}
int pc_runfloor_sub(struct block_list *bl, va_list ap) {
	struct npc_data *nd;
	struct map_sessiondata *sd;
	if (bl->subtype!=FLOOR)
		return 0;

	nullpo_ret(nd=(struct npc_data*)bl);
	nullpo_ret(sd=va_arg(ap,struct map_sessiondata*));

	run_script(nd->u.scr.script,0,sd->bl.id,nd->bl.id);
	return 0;
}

int pc_setpos(struct map_sessiondata *sd,int m,int x,int y) {
	sd->bl.m = m;
	sd->bl.x = x;
	sd->bl.y = y;
	sd->bl.type = BL_PC;

	return 0;
}

int pc_changehair(struct map_sessiondata *sd,int value) {
	sd->status.hair=value;
	clif_sendchararea(sd);
	clif_getchararea(sd);
}
int pc_changehaircolor(struct map_sessiondata *sd,int value) {
	sd->status.hair_color=value;
	clif_sendchararea(sd);
	clif_getchararea(sd);
}
int pc_changearmorcolor(struct map_sessiondata *sd,int value) {
	sd->status.armor_color=value;
	clif_sendchararea(sd);
	clif_getchararea(sd);
}
int pc_changeface(struct map_sessiondata *sd,int value) {
	sd->status.face=value;
	clif_sendchararea(sd);
	clif_getchararea(sd);
}
int pc_changemoney(struct map_sessiondata *sd,int value) {
	sd->status.money = value;
	clif_sendstatus(sd);
	return 0;
}
int pc_changeexp(struct map_sessiondata *sd,int value) {
	sd->status.exp = value;
	clif_sendstatus(sd);
	return 0;
}
int pc_changeclass(struct map_sessiondata *sd,int value) {
	sd->status.class = value;
	clif_mystaytus(sd);
	return 0;
}
int pc_changesubclass(struct map_sessiondata *sd,int value) {
	sd->status.subclass = value;
	clif_mystaytus(sd);
	return 0;
}
int pc_changetitle(struct map_sessiondata *sd,char *title) {
	strcpy(sd->status.title,title);
	clif_mystaytus(sd);
	return 0;
}
int pc_changeclantitle(struct map_sessiondata *sd,char *clan_title) {
	strcpy(sd->status.clan_title,clan_title);
	clif_mystaytus(sd);
	return 0;
}
int pc_changeclan(struct map_sessiondata *sd,int id) {
	sd->status.clan_id = id;
	clif_mystaytus(sd);
	return 0;
}
int pc_warp(struct map_sessiondata *sd,int m,int x,int y) {
	if(m < 0)
		return 0;

	if (!map_isloaded(m)) {
		//Nothing happen
		//We must discover change server packet first!!
		return 0;
	}

	if (x < 0) x = 0;
	if (y < 0) y = 0;
	if (x >= map[m].xs) x = map[m].xs-1;
	if (y >= map[m].ys) y = map[m].ys-1;

	clif_quit(sd);
	pc_setpos(sd,m,x,y);
	clif_sendtime(sd);
	clif_sendmapinfo(sd);
	clif_sendxy(sd);
	clif_spawn(sd);
	clif_getchararea(sd);
	return 0;
}

int pc_itemid2inventoryid(struct map_sessiondata *sd, int item_id)
{
	int i;
	for(i=0; i<26; i++)	{
		if(sd->status.inventory[i].id == item_id) return i;
	}

	return -1;
}

int pc_itemcount(struct map_sessiondata *sd, int item_id)
{
	int slot;
	slot = pc_itemid2inventoryid(sd, item_id);
	
	if(slot == -1){ return 0; }
	else { return sd->status.inventory[slot].amount; }
}

int pc_giveitem(struct map_sessiondata *sd, int itemid, int amount) {
	struct item it;

	memset(&it,0,sizeof(struct item));
	it.id = itemid;
	it.dura = itemdb_dura(itemid);
	it.amount = amount;
	strcpy(it.real_name, itemdb_name(itemid));

	return pc_additem(sd, &it);
}

int pc_loaditem(struct map_sessiondata *sd) {
	int i;
	for (i=0;i<26;i++) {
		if (sd->status.inventory[i].id) {
			clif_sendadditem(sd, i);
		}
	}
	return 0;
}

int pc_loadequip(struct map_sessiondata *sd) {
	int i;
	for (i=0;i<15;i++) {
		if (sd->status.equip[i].id>0) {
			clif_sendequip(sd, i);
			//printf("Omg: %d\n",i);
			//sd->target=sd->bl.id;
			//run_script(itemdb_equipscript(sd->status.equip[i].id),0,sd->bl.id,0);
		}
	}
	return 0;
}

int pc_isinvenspace(struct map_sessiondata *sd, int id) {
	int i;
	for(i=0;i<26;i++) {
		if (!sd->status.inventory[i].id)
			break;
		if (sd->status.inventory[i].id == id && sd->status.inventory[i].amount < itemdb_maxamount(id))
			break;
	}
	return i;
}

int pc_isinvenitemspace(struct map_sessiondata *sd, int num, int id) {
	if (!sd->status.inventory[num].id)
		return itemdb_maxamount(id);
	if (sd->status.inventory[num].id != id)
		return 0;
	return itemdb_maxamount(id)-sd->status.inventory[num].amount;
}

int pc_additem(struct map_sessiondata *sd, struct item *fl) {
	int num;
	int i;
	if ((num=pc_isinvenspace(sd, fl->id))>=26) {
		clif_sendminitext(sd, map_msg[MAP_ERRITMFULL].message, map_msg[MAP_ERRITMFULL].len);
		return 1;
	}
	
	if(itemdb_maxhave(fl->id) == 0) {
		for(i=0;i<26;i++) {
			if(sd->status.inventory[i].id == fl->id) {
				sd->status.inventory[i].id = fl->id;
				sd->status.inventory[i].dura = fl->dura;
				sd->status.inventory[i].owner_id = fl->owner_id;
				strcpy(sd->status.inventory[i].real_name, fl->real_name);
				if(fl->amount >( num=pc_isinvenitemspace(sd, i, fl->id) ) ) {
					fl->amount -= num;
					sd->status.inventory[i].amount += num;
				} else {
					sd->status.inventory[i].amount+=fl->amount;
					fl->amount = 0;
				}

				
		//		clif_sendadditem(sd, i);
				break;
			}
		}
		
		if(i>=26) {
			i=0;
			while(i<26) {
				if(sd->status.inventory[i].id == 0) break;
				i++;
			}
			sd->status.inventory[i].id = fl->id;
			sd->status.inventory[i].dura = fl->dura;
			sd->status.inventory[i].owner_id = fl->owner_id;
			strcpy(sd->status.inventory[i].real_name, fl->real_name);
			if(fl->amount >( num=pc_isinvenitemspace(sd, i, fl->id) ) ) {
				fl->amount -= num;
				sd->status.inventory[i].amount= num;
			} else {
				sd->status.inventory[i].amount=fl->amount;
				fl->amount = 0;
			}	
			
		}
		if(fl->amount>0) {
			char buf[256]={0,};
			int len=sprintf(buf,map_msg[MAP_ERRITMCFULL].message, itemdb_name(fl->id), itemdb_maxamount(fl->id));
			clif_sendminitext(sd, buf, len);
			return 1;
		} else {
			clif_sendadditem(sd, i);
		}
	} else {
		if(itemdb_maxamount(fl->id) == 0) {
			for(i=0;i<26;i++) {
				if(sd->status.inventory[i].id==0) {
					//    â  ִ°
					sd->status.inventory[i].id = fl->id;
					sd->status.inventory[i].dura = fl->dura;
					sd->status.inventory[i].owner_id = fl->owner_id;
					strcpy(sd->status.inventory[i].real_name, fl->real_name);
					fl->amount = 0;
					sd->status.inventory[i].amount = 1;
					clif_sendadditem(sd, i);
					return 0;
				}
				
			}
		} else { // Ѱۿ (Ʈ۰)
			for(i=0;i<26;i++) {
				if(sd->status.inventory[i].id == fl->id) {
					char buf[256]={0,};
					int len=sprintf(buf, map_msg[MAP_ERRITMFULL2].message, itemdb_name(fl->id));
					clif_sendminitext(sd, buf, len);
					return 1;
				}
			}
			i=0;
			while(i<26) {
				if(sd->status.inventory[i].id == 0) break;
				i++;
			}
			sd->status.inventory[i].id = fl->id;
			sd->status.inventory[i].dura = fl->dura;
			sd->status.inventory[i].owner_id = fl->owner_id;
			strcpy(sd->status.inventory[i].real_name, fl->real_name);
			fl->amount=0;
			sd->status.inventory[i].amount=1;
			clif_sendadditem(sd, i);
		}
	}
	return 0;
}

int pc_delitem(struct map_sessiondata *sd, int id, int amount, int type) {
	if (!sd->status.inventory[id].id)
		return 0;

	sd->status.inventory[id].amount-=amount;
	if (sd->status.inventory[id].amount <=0) {
		memset(&sd->status.inventory[id],0,sizeof(struct item));
		clif_senddelitem(sd, id, type);
	} else
		clif_sendadditem(sd, id);
	return 0;
}

int pc_canequipitem(struct map_sessiondata *sd, int id) {
	int itemid = sd->status.inventory[id].id;
	if(sd->status.gm_level) return 0;
	if (sd->status.level < itemdb_level(itemid))
		return MAP_ERRITMLEVEL;
	if ((unsigned char)sd->might < (unsigned char)itemdb_might(itemid))
		return MAP_ERRITMMIGHT;
	if (sd->status.sex != itemdb_sex(itemid) && itemdb_sex(itemid) != 2)
		return MAP_ERRITMSEX;
	
	if (sd->status.class != itemdb_class(itemid) && itemdb_sex(itemid))
		return MAP_ERRITMCLASS;
	if (sd->status.subclass < itemdb_subclass(itemid))
		return MAP_ERRITMSUBCLASS;
	
	
	return 0;
}

int pc_equipitem(struct map_sessiondata *sd, int id) {
	int ret;
	struct item it;
	if (!sd->status.inventory[id].id)
		return 0;

	

	ret=pc_canequipitem(sd, id);
	if (ret) {
	//	printf(" ERR MSG TYPE : %d\n",ret);
		clif_sendminitext(sd, map_msg[ret].message, map_msg[ret].len);
		return 0;
	}

	ret=itemdb_type(sd->status.inventory[id].id);
	
	if (ret < 3 || ret > 12) {//not equip item
		printf("pc_equipitem(): exception happened\n");
		return 0;
	}

	if(ret == ITM_WEAP) {
		ret=EQ_WEAP;
	}
	
	else if(ret == ITM_HELM) {
		ret=EQ_HELM;
	}

	else if(ret == ITM_ARMOR) {
		ret=EQ_ARMOR;
	}
	else if (ret == ITM_WEAP_2H ) {
		if(sd->status.equip[EQ_SHIELD].id !=0 ) {
			clif_sendminitext(sd, map_msg[MAP_ERRITM2H].message, map_msg[MAP_ERRITM2H].len);
			return 0;
		}
		ret=EQ_WEAP;
	} else if (ret == ITM_SHIELD ) {
		if(itemdb_type(sd->status.equip[EQ_WEAP].id) == ITM_WEAP_2H ) {
			clif_sendminitext(sd, map_msg[MAP_ERRITM_WITH2H].message, map_msg[MAP_ERRITM_WITH2H].len);
			return 0;
		}
		ret=EQ_SHIELD;
	}
	


	else if (ret == ITM_HAND) {
		if (sd->status.equip[EQ_LEFT].id==0)
			ret=EQ_LEFT;
		else if(sd->status.equip[EQ_RIGHT].id==0)
			ret=EQ_RIGHT;
		else {
			ret =EQ_LEFT;
		}
	} else if (ret == ITM_SCRIPT) {
		if (sd->status.equip[EQ_SCRIPT1].id==0)
			ret=EQ_SCRIPT1;
		else if(sd->status.equip[EQ_SCRIPT2].id==0)
			ret=EQ_SCRIPT2;
		else {
			ret =EQ_SCRIPT1;
		}
	}
//	printf(" EQUIP TYPE : %d\n",ret);
	if (sd->status.equip[ret].id) {
//		printf("%dԿ ",ret);
		sd->target=sd->bl.id;
		run_script(itemdb_unequipscript(sd->status.equip[ret].id),0,sd->bl.id,0);
		memcpy(&it, &sd->status.equip[ret], sizeof(struct item));
		memcpy(&sd->status.equip[ret], &sd->status.inventory[id], sizeof(struct item));
		
		pc_delitem(sd, id, 1, 0x0C);
		pc_additem(sd, &it);
	} else {
//		printf("%dԿ ",ret);
		memcpy(&sd->status.equip[ret], &sd->status.inventory[id], sizeof(struct item));
		pc_delitem(sd, id, 1, 0x0C);
	}

	clif_sendequip(sd, ret);
	sd->status.equip[ret].amount=1;
	
	pc_calcstat(sd);
	if(ret!=EQ_WEAP) {
		char buf[256]={0,};
		int len=sprintf(buf,map_msg[MAP_EQUIP_ITEM].message, (char)sd->ac, sd->protection);
		clif_sendminitext(sd,buf,len);
	}
	if(ret!= EQ_SCRIPT1 && ret!= EQ_SCRIPT2 &&
		ret!= EQ_LEFT && ret!= EQ_RIGHT) clif_sendchararea2(sd);
	
	return 0;
}

int pc_unequip(struct map_sessiondata *sd, int type) {
	struct item it;
	
	if(sd->status.equip[type].id==0)
		return 1;
	memcpy(&it, &sd->status.equip[type], sizeof(struct item));
	if(&it.id<=0)
		return 1;
	
	if (pc_additem(sd, &it))
		return 1;

	memset(&sd->status.equip[type], 0, sizeof(struct item));
	strcpy(sd->status.equip[type].real_name,"");
	sd->target=sd->bl.id;
	run_script(itemdb_unequipscript(sd->status.equip[type].id),0,sd->bl.id,0);
	pc_calcstat(sd);
	clif_sendchararea(sd);
	if (type > 0 && type < 15)
		clif_sendchararea(sd);
	return 0;
}

int pc_getitemmap(struct map_sessiondata *sd, int type) {
	struct flooritem_data *fl;
	struct item it;

	// type: 1 = get all item in the cell
	// type: 0 = get item first in the cell
start: // if type = 1, retrying to find another item
	fl=(struct flooritem_data *)map_firstincell(sd->bl.m,sd->bl.x,sd->bl.y,BL_ITEM);
	
	
	if(fl==NULL) return 0;
	if(itemdb_checkifcash(fl->data.id)) {
		// if it's cash
		if(pc_getmoney(sd,fl->data.amount)) {
			clif_lookgone(&fl->bl);
			map_delitem(fl->bl.id);
		//	if(type) goto start;

			return 1;
		}
	}
	if (type)
		pc_additem(sd, &fl->data);
	else {
		memcpy(&it, &fl->data, sizeof(struct item));
		it.amount=1;
		if(!pc_additem(sd, &it))
			fl->data.amount--;
	}

	if (fl->data.amount <= 0) {
		clif_lookgone(&fl->bl);
		map_delitem(fl->bl.id);
	}
//	if(type) 
//		goto start;
	return 1;
}
int pc_delmoney(struct map_sessiondata *sd, int money) {
	nullpo_ret(sd);
	if(sd->status.money < money) {
		return 0;
	} else {
		sd->status.money-=money;
		clif_sendstatus(sd);
		return 1;
	}
}

int pc_getmoney(struct map_sessiondata *sd, int money) {
	nullpo_ret(sd);
	if(sd->status.money+money > MAX_MONEY) {
		// you can't have money over 10000000
		clif_sendminitext(sd,map_msg[MAP_ERRMONEYMAX].message,map_msg[MAP_ERRMONEYMAX].len);
		return 0;
	} else {
		sd->status.money+=money;
		clif_sendstatus(sd);
		return 1;
	}
}

int pc_dropitemmap(struct map_sessiondata *sd, int id, int type) {
	struct flooritem_data *fl;
	if (!sd->status.inventory[id].id)
		return 0;

	
	CREATE(fl, struct flooritem_data, 1);

	fl->bl.m = sd->bl.m;
	fl->bl.x = sd->bl.x;
	fl->bl.y = sd->bl.y;

	memcpy(&fl->data, &sd->status.inventory[id], sizeof(struct item));

	sd->status.inventory[id].amount--;

	if(type || !sd->status.inventory[id].amount) {
		memset(&sd->status.inventory[id], 0, sizeof(struct item));
		clif_senddelitem(sd, id, 1);
	} else {
		fl->data.amount = 1;
		clif_sendadditem(sd, id);
	}

	map_additem(&fl->bl);
	map_foreachinarea(clif_itemlook_sub,sd->bl.m,sd->bl.x,sd->bl.y,AREA,BL_PC,LOOK_SEND,fl);
	return 0;
}

int pc_dropmoney( struct map_sessiondata *sd, int money) {
	struct flooritem_data *fl;
	if(sd->status.money < money) {
		// 
		money=sd->status.money;
	}
	sd->status.money-=money;
	CREATE(fl, struct flooritem_data, 1);
	fl->bl.m = sd->bl.m;
	fl->bl.x = sd->bl.x;
	fl->bl.y = sd->bl.y;
	
	fl->data.amount=money;
	if( money >= 1000 ) fl->data.id=cashs.gold;
	else if(money == 1) fl->data.id=cashs.dong;
	else if(money < 100) fl->data.id=cashs.dongs;
	else if(money >= 100) fl->data.id=cashs.silvers;


	map_additem(&fl->bl);
	clif_sendstatus(sd);
	map_foreachinarea(clif_itemlook_sub,sd->bl.m,sd->bl.x,sd->bl.y,AREA,BL_PC,LOOK_SEND,fl);
	
	return 0;
	
}

int pc_changeitem(struct map_sessiondata *sd, int id1, int id2) {
	struct item tmp;
	memcpy(&tmp, &sd->status.inventory[id2], sizeof(struct item));
	memcpy(&sd->status.inventory[id2], &sd->status.inventory[id1], sizeof(struct item));
	memcpy(&sd->status.inventory[id1], &tmp, sizeof(struct item));
	if (sd->status.inventory[id1].id) {
		if (!sd->status.inventory[id2].id)
			clif_senddelitem(sd, id2, 0);
		clif_sendadditem(sd, id1);
	}
	if (sd->status.inventory[id2].id) {
		if (!sd->status.inventory[id1].id)
			clif_senddelitem(sd, id1, 0);
		clif_sendadditem(sd, id2);
	}
	return 0;
}

int pc_useitem(struct map_sessiondata *sd, int id) {
	int type;
	if (!sd->status.inventory[id].id)
	{
//		printf("item ,state: %d,%d\n",sd->status.state,PC_DIE);
		return 0;
	}
	
	
//	printf(" ֳ, state: %d,%d\n",sd->status.state,PC_DIE);
	
	type= itemdb_type(sd->status.inventory[id].id);
	switch(sd->status.state) {
	case PC_DIE: 
		if( type!=ITM_USESPC ) {
			clif_sendminitext(sd, map_msg[MAP_ERRGHOST].message, map_msg[MAP_ERRGHOST].len);
			return 0;
		}
		break;
	case PC_ALIVE:
		break;
	case PC_HORSE:
		{
			clif_sendminitext(sd, map_msg[MAP_ERRHORSE].message, map_msg[MAP_ERRHORSE].len);
			return 0;
		}
		break;
	case PC_INVIS:
		if( type != ITM_WEAP || type != ITM_EAT || type != ITM_SMOKE/* || type != ITM_DRINK */) {
			clif_sendminitext(sd, map_msg[MAP_ERRINVIS].message, map_msg[MAP_ERRINVIS].len);
			return 0;
		}
		break;
	}

	switch(itemdb_type(sd->status.inventory[id].id)) {
	case ITM_EAT:
		run_script(itemdb_script(sd->status.inventory[id].id),0,sd->bl.id,0);
		clif_sendaction(sd,8,39,0);
		pc_delitem(sd,id,1,2);
		break;
	case ITM_USE:
	case ITM_USESPC:
		run_script(itemdb_script(sd->status.inventory[id].id),0,sd->bl.id,0);
		pc_delitem(sd,id,1,6);
		break;
	case ITM_SMOKE:
		run_script(itemdb_script(sd->status.inventory[id].id),0,sd->bl.id,0);
		pc_dcrs_itemdura(sd, id);
		
		break;
	case ITM_HELM:
	case ITM_WEAP:
	case ITM_ARMOR:
	case ITM_HAND:
	case ITM_SHIELD:
	case ITM_WEAP_2H:
	case ITM_SCRIPT:
		pc_equipitem(sd, id);
		break;
	case ITM_ETC:
		run_script(itemdb_script(sd->status.inventory[id].id),0,sd->bl.id,0);
	default:
		break;
	}
	return 0;
}

/*==========================================
 * scriptp??̒l?
 *------------------------------------------
 */
int pc_readreg(struct map_sessiondata *sd,int reg)
{
	int i;

	nullpo_retr(0, sd);

	for(i=0;i<sd->reg_num;i++)
		if(sd->reg[i].index==reg)
			return sd->reg[i].data;

	return 0;
}
/*==========================================
 * scriptp??̒lݒ
 *------------------------------------------
 */
int pc_setreg(struct map_sessiondata *sd,int reg,int val)
{
	int i;

	nullpo_retr(0, sd);

	for (i = 0; i < sd->reg_num; i++) {
		if (sd->reg[i].index == reg){
			sd->reg[i].data = val;
			return 0;
		}
	}
	sd->reg_num++;
	sd->reg = (struct script_reg *) aRealloc(sd->reg, sizeof(*(sd->reg)) * sd->reg_num);
	memset(sd->reg + (sd->reg_num - 1), 0, sizeof(struct script_reg));
	sd->reg[i].index = reg;
	sd->reg[i].data = val;

	return 0;
}


/*==========================================
 * script Read&Set PC Reg
 *------------------------------------------
 */
char *pc_readregstr(struct map_sessiondata *sd,int reg)
{
	int i;

	nullpo_retr(0, sd);

	for(i=0;i<sd->regstr_num;i++)
		if(sd->regstr[i].index==reg)
			return sd->regstr[i].data;

	return NULL;
}
/*==========================================
 * scriptp??̒lݒ
 *------------------------------------------
 */
int pc_setregstr(struct map_sessiondata *sd,int reg,char *str)
{
	int i;

	nullpo_retr(0, sd);

	if(strlen(str)+1 >= sizeof(sd->regstr[0].data)){
		ShowWarning("pc_setregstr: string too long !\n");
		return 0;
	}

	for(i=0;i<sd->regstr_num;i++)
		if(sd->regstr[i].index==reg){
			strcpy(sd->regstr[i].data,str);
			return 0;
		}

	sd->regstr_num++;
	sd->regstr = (struct script_regstr *) aRealloc(sd->regstr, sizeof(sd->regstr[0]) * sd->regstr_num);
	if(sd->regstr==NULL){
		ShowFatalError("out of memory : pc_setreg\n");
		exit(1);
	}
	memset(sd->regstr + (sd->regstr_num - 1), 0, sizeof(struct script_regstr));
	sd->regstr[i].index = reg;
	strcpy(sd->regstr[i].data, str);

	return 0;
}

int pc_readregistry(struct map_sessiondata *sd,const char *reg) {
	struct global_reg *sd_reg;
	int i,max;
	
	nullpo_retr(0, sd);
	
	//Char reg
	sd_reg = sd->save_reg.global;
	max = sd->save_reg.global_num;
	

	if (max == -1) {
//		if (battle_config.error_log)
			ShowError("pc_readregistry: Trying to read reg value %s before it's been loaded!\n", reg);
		//This really shouldn't happen, so it's possible the data was lost somewhere, we should request it again.
		intif_request_registry(sd);
		return 0;
	}
	for(i=0;i<max;i++){
		if(strcmp(sd_reg[i].str,reg)==0)
			return atoi(sd_reg[i].value);
	}
	return 0;
}

char* pc_readregistry_str(struct map_sessiondata *sd,char *reg) {
	struct global_reg *sd_reg;
	int i,max;
	
	nullpo_retr(0, sd);
	sd_reg = sd->save_reg.global;
	max = sd->save_reg.global_num;
	
	if (max == -1) {
//		if (battle_config.error_log)
			ShowError("pc_readregistry: Trying to read reg value %s before it's been loaded!\n", reg);
		//This really shouldn't happen, so it's possible the data was lost somewhere, we should request it again.
		intif_request_registry(sd);
		return NULL;
	}
	for(i=0;i<max;i++){
		if(strcmp(sd_reg[i].str,reg)==0)
			return sd_reg[i].value;
	}
	return NULL;
}

int pc_setregistry(struct map_sessiondata *sd,const char *reg,int val) {
	struct global_reg *sd_reg;
	int i,*max, regmax;

	nullpo_retr(0, sd);
/*	if (type == 3) { //Some special character reg values...
		if(strcmp(reg,"PC_DIE_COUNTER") == 0 && sd->die_counter != val){
			i = (!sd->die_counter && (sd->class_&MAPID_UPPERMASK) == MAPID_SUPER_NOVICE);
			sd->die_counter = val;
			if (i) status_calc_pc(sd,0); //Lost the bonus.
		} else if(strcmp(reg,script_config.die_event_name) == 0){
			sd->state.event_death = val;
		} else if(strcmp(reg,script_config.kill_pc_event_name) == 0){
			sd->state.event_kill_pc = val;
		} else if(strcmp(reg,script_config.kill_mob_event_name) == 0){
			sd->state.event_kill_mob = val;
		} else if(strcmp(reg,script_config.logout_event_name) == 0){
			sd->state.event_disconnect = val;
		}
		}
	*/
	//Char reg
	sd_reg = sd->save_reg.global;
	max = &sd->save_reg.global_num;
	regmax = GLOBAL_REG_NUM;


	if (*max == -1) {
//		if(battle_config.error_log)
			ShowError("pc_setregistry : refusing to set %s until vars are received.\n", reg);
		return 1;
	}
	
	// delete reg
	if (val == 0) {
		for(i = 0; i < *max; i++) {
			if (strcmp(sd_reg[i].str, reg) == 0) {
				if (i != *max - 1)
					memcpy(&sd_reg[i], &sd_reg[*max - 1], sizeof(struct global_reg));
				memset(&sd_reg[*max - 1], 0, sizeof(struct global_reg));
				(*max)--;
				sd->state.reg_dirty = 1; //Mark this registry as "need to be saved"
				break;
			}
		}
		return 0;
	}
	// change value if found
	for(i = 0; i < *max; i++) {
		if (strcmp(sd_reg[i].str, reg) == 0) {
			sprintf(sd_reg[i].value, "%d", val); 
			sd->state.reg_dirty = 1;
			return 0;
		}
	}

	// add value if not found
	if (i < regmax) {
		memset(&sd_reg[i], 0, sizeof(struct global_reg));
		strncpy(sd_reg[i].str, reg, 32);
		sprintf(sd_reg[i].value, "%d", val); 
		(*max)++;
		sd->state.reg_dirty = 1;
		return 0;
	}

//	if(battle_config.error_log)
		ShowError("pc_setregistry : couldn't set %s, limit of registries reached (%d)\n", reg, regmax);

	return 1;
}

int pc_setregistry_str(struct map_sessiondata *sd,char *reg,char *val) {
	struct global_reg *sd_reg;
	int i,*max, regmax;

	nullpo_retr(0, sd);
	if (reg[strlen(reg)-1] != '$') {
//		if(battle_config.error_log)
			ShowError("pc_setregistry_str : reg %s must be string (end in '$') to use this!\n", reg);
			return 1;
	}
	
	
	//Char reg
	sd_reg = sd->save_reg.global;
	max = &sd->save_reg.global_num;
	regmax = GLOBAL_REG_NUM;


	if (*max == -1) {
//		if(battle_config.error_log)
			ShowError("pc_setregistry_str : refusing to set %s until vars are received.\n", reg);
		return 1;
	}
	
	// delete reg
	if (strcmp(val,"")==0) {
		for(i = 0; i < *max; i++) {
			if (strcmp(sd_reg[i].str, reg) == 0) {
				if (i != *max - 1)
					memcpy(&sd_reg[i], &sd_reg[*max - 1], sizeof(struct global_reg));
				memset(&sd_reg[*max - 1], 0, sizeof(struct global_reg));
				(*max)--;
				sd->state.reg_dirty = 1; //Mark this registry as "need to be saved"
				intif_saveregistry(sd);
				break;
			}
		}
		return 0;
	}
	// change value if found
	for(i = 0; i < *max; i++) {
		if (strcmp(sd_reg[i].str, reg) == 0) {
			strncpy(sd_reg[i].value, val, 256);
			sd->state.reg_dirty = 1; //Mark this registry as "need to be saved"
			intif_saveregistry(sd);
			return 0;
		}
	}

	// add value if not found
	if (i < regmax) {
		memset(&sd_reg[i], 0, sizeof(struct global_reg));
		strncpy(sd_reg[i].str, reg, 32);
		strncpy(sd_reg[i].value, val, 256);
		(*max)++;
		sd->state.reg_dirty = 1; //Mark this registry as "need to be saved"
		intif_saveregistry(sd);
		return 0;
	}

//	if(battle_config.error_log)
		ShowError("pc_setregistry : couldn't set %s, limit of registries reached (%d)\n", reg, regmax);

	return 1;
}





int pc_readparam(struct map_sessiondata *sd,int type) {
	int val=0;
	
	nullpo_ret( sd);
	
	switch (type) {
	case SP_HP:
		val=sd->status.hp;
		break;
	case SP_MP:
		val=sd->status.mp;
		break;
	case SP_MHP:
		val=sd->max_hp;
		break;
	case SP_MMP:
		val=sd->max_mp;
		break;
	}
	return val;
}



/*==========================================
 * Cxg^C}??
 *------------------------------------------
 */
static int pc_eventtimer(int tid,unsigned int tick,int id,int data)
{
	struct map_sessiondata *sd=map_id2sd(id);
	char *p = (char *)data;
	int i;
	if(sd==NULL)
		return 0;

	for(i=0;i < MAX_EVENTTIMER && sd->eventtimer[i]!=tid; i++);

	if(i < MAX_EVENTTIMER){
		sd->eventcount--;
		sd->eventtimer[i]=-1;
		npc_event(sd,p,0);
	} else //if(battle_config.error_log)
		ShowError("pc_eventtimer: no such event timer\n");

	if (p) aFree(p);
	return 0;
}

int pc_addeventtimer(struct map_sessiondata *sd,int tick,const char *name)
{
	int i;
	char *evname;

	nullpo_retr(0, sd);

	for(i=0;i<MAX_EVENTTIMER && sd->eventtimer[i]!=-1;i++);
	
	if(i==MAX_EVENTTIMER)
		return 0;

	evname = aStrdup(name);
	sd->eventtimer[i]=add_timer(gettick()+tick,
		pc_eventtimer,sd->bl.id,(int)evname);
	sd->eventcount++;

	return 1;
}

/*==========================================
 * Cxg^C}?폜
 *------------------------------------------
 */
int pc_deleventtimer(struct map_sessiondata *sd,const char *name)
{
	int i;

	nullpo_retr(0, sd);

	if (sd->eventcount <= 0)
		return 0;

	for(i=0;i<MAX_EVENTTIMER;i++)
		if( sd->eventtimer[i]!=-1 ) {
			char *p = (char *)(get_timer(sd->eventtimer[i])->data);
			if(p && strcmp(p, name)==0) {
				delete_timer(sd->eventtimer[i],pc_eventtimer);
				sd->eventtimer[i]=-1;
				sd->eventcount--;
				aFree(p);
				return 1;
			}
		}

	return 0;
}

/*==========================================
 * Cxg^C}?JEglǉ
 *------------------------------------------
 */
int pc_addeventtimercount(struct map_sessiondata *sd,const char *name,int tick)
{
	int i;

	nullpo_retr(0, sd);

	for(i=0;i<MAX_EVENTTIMER;i++)
		if( sd->eventtimer[i]!=-1 && strcmp(
			(char *)(get_timer(sd->eventtimer[i])->data), name)==0 ){
				addtick_timer(sd->eventtimer[i],tick);
				break;
		}

	return 0;
}

/*==========================================
 * Cxg^C}?S폜
 *------------------------------------------
*/
int pc_cleareventtimer(struct map_sessiondata *sd)
{
	int i;
	
	nullpo_retr(0, sd);
	
	if (sd->eventcount <= 0)
		return 0;
	
	for(i=0;i<MAX_EVENTTIMER;i++) {
		if( sd->eventtimer[i]!=-1 ){
			char *p = (char *)(get_timer(sd->eventtimer[i])->data);
			delete_timer(sd->eventtimer[i],pc_eventtimer);
			sd->eventtimer[i]=-1;
			sd->eventcount--;
			if (p) aFree(p);
		}
	}
	return 0;
}


int pc_setparam(struct map_sessiondata *sd,int type,int val) {
	nullpo_ret( sd);
	switch (type) {
	case SP_HP:
		sd->status.hp=val;
		break;
	case SP_MP:
		sd->status.mp=val;
		break;
	case SP_MHP:
		sd->max_hp=val;
		break;
	case SP_MMP:
		sd->max_mp=val;
		break;
	}
	clif_sendupdatestatus(sd);
	return 0;
}

int pc_die(struct map_sessiondata *sd) {
	sd->status.state = PC_DIE;
	sd->status.hp = 0;
	sd->status.mp = 0;
	clif_sendupdatestatus(sd);
	clif_sendchararea(sd);
	return 0;
}

int pc_res(struct map_sessiondata *sd) {
	if(sd->status.state==PC_DIE) {
		sd->status.state = PC_ALIVE;
		sd->status.hp = 100;
		clif_sendupdatestatus(sd);
		clif_sendchararea(sd);
	}
	return 0;
}



int pc_heal(struct map_sessiondata *sd, int hp, int mp) {
	if (mp<0 && abs(mp)>=sd->status.mp) {
		sd->status.mp = 0;
	} else if (mp>=sd->max_mp-sd->status.mp && mp>0) {
		sd->status.mp = sd->max_mp;
	} else {
		sd->status.mp += mp;
	}

	if (hp<0 && abs(hp)>=sd->status.hp) {
		sd->status.hp = 0;
	} else if (hp>=sd->max_hp-sd->status.hp && hp>0) {
		sd->status.hp = sd->max_hp;
	} else {
		sd->status.hp += hp;
	}

	if (!sd->status.hp && sd->status.state!=PC_DIE)
		pc_die(sd);
	else
		clif_sendupdatestatus(sd);	
	return 0;
}

int pc_uncast(struct map_sessiondata *sd) {
	int x;
	for(x=0;x<50;x++) {
		if(sd->status.dura_aether[x].id>0) {
			sd->status.dura_aether[x].id=0;
			if(sd->status.dura_aether[x].aether>0) {
				clif_send_aether(sd,sd->status.dura_aether[x].id,0);
			}
			sd->status.dura_aether[x].duration=0;
			sd->status.dura_aether[x].aether=0;
			sd->target=0;
			run_script(magicdb_script3(sd->status.dura_aether[x].id),0,sd->bl.id,0);
			
			clif_send_duration(sd,sd->status.dura_aether[x].id,0);
		}
	}
}

int pc_damaged(struct map_sessiondata *sd, int damage) {
	int last_dam=damage;
	int dam_plus;

	nullpo_ret(sd);
	if(sd->ac== 0) return damage;
	dam_plus=damage/sd->ac;
	last_dam+=dam_plus;
	sd->status.hp-=last_dam;
//	printf("pc_damaged(): %d %d %d %d\n",damage,sd->ac,dam_plus,last_dam);
	return last_dam;
}

int pc_itemname_check(struct map_sessiondata *sd) {
	int i;
	for(i=0;i<26;i++) {
		if(!sd->status.inventory[i].id)
			strcpy(sd->status.inventory[i].real_name,"");
	}

	for(i=0;i<9;i++) {
		if(!sd->status.equip[i].id)
			strcpy(sd->status.equip[i].real_name,"");
	}

}

int pc_randomwarp(struct map_sessiondata *sd, int type) {
	int x,y,i=0;
	int m;

	nullpo_retr(0, sd);

	m=sd->bl.m;

	if (map[sd->bl.m].flag.noteleport)	// e|?g֎~
		return 0;

	do{
		x=rand()%(map[m].xs-2)+1;
		y=rand()%(map[m].ys-2)+1;
	}while(pc_canmove(m,x,y) && (i++)<1000 );

	if (i < 1000)
		return pc_setpos(sd,map[sd->bl.m].id,x,y,type);

	return 0;
}

int pc_canmove(int m, int x, int y) {
	//  üũ..
	if(map_canmove(m,x,y))
		return 1;
	// ü üũ..
	if(map_firstincell2(m,x,y,0)) {
		return 1;
	}
	return 0;
}
int pc_searchlegend(struct map_sessiondata *sd, char *msg) {
	int i;
	for(i=0; i<sd->legend_list.legend_num; i++) {
		if(!strcmp(msg, sd->legend_list.legends[i].text)) {
			return i;
		}
	}
	return -1;
}

int pc_addlegend(struct map_sessiondata *sd, int icon , int color, char msg[] ) {
	int target;
	if(sd->legend_list.legend_num >= MAX_LEGEND) {
		return 0;
	}
	target = sd->legend_list.legend_num;
	sd->legend_list.legends[target].icon = icon;
	sd->legend_list.legends[target].color = color;
	sd->legend_list.legends[target].len = strlen(msg);
	sprintf(sd->legend_list.legends[target].text,msg);
	sd->legend_list.legend_num++;
	sd->state.leg_dirty = 1;

	return 1;
}
int pc_modifylegend(struct map_sessiondata *sd, int icon , int color, char *targetmsg, char *newmsg) {
	int target;
	target = pc_searchlegend(sd, targetmsg);
	if(target < 0) {
		return 0;
	}
	
	sd->legend_list.legends[target].icon = icon;
	sd->legend_list.legends[target].color = color;
	sd->legend_list.legends[target].len = strlen(newmsg);
	sprintf(sd->legend_list.legends[target].text,newmsg);
	sd->state.leg_dirty = 1;
	return 1;
}

int pc_dellegend(struct map_sessiondata *sd, char *msg) {
	int target;
	target = pc_searchlegend(sd, msg);
	if(target < 0) {
		return 0;
	}
	sd->legend_list.legends[target].icon = 0;
	sd->legend_list.legends[target].color = 0;
	sd->legend_list.legends[target].len = 0;
	memset(sd->legend_list.legends[target].text,0,sizeof(sd->legend_list.legends[target].text));
	sd->state.leg_dirty = 1;

	return 1;
}
