
#ifndef _PC_H_
#define _PC_H_

#include <stdarg.h>
#include "../common/mmo.h"
int pc_magic_startup(struct map_sessiondata*);
int pc_givexp(struct map_sessiondata*,int,int);
int pc_runfloor_sub(struct block_list*,va_list);
int pc_isequip(struct map_sessiondata*,int);
int pc_setpos(struct map_sessiondata*,int,int,int);
int pc_warp(struct map_sessiondata*,int,int,int);
int pc_calcstat(struct map_sessiondata*);
int pc_loaditem(struct map_sessiondata*);
int pc_loadequip(struct map_sessiondata*);
int pc_additem(struct map_sessiondata*,struct item*);
int pc_delitem(struct map_sessiondata*,int,int,int);
int pc_useitem(struct map_sessiondata*,int);
int pc_dropitemmap(struct map_sessiondata*,int,int);
int pc_getitemmap(struct map_sessiondata*,int);
int pc_changeitem(struct map_sessiondata*,int,int);
int pc_equipitem(struct map_sessiondata*,int);
int pc_unequip(struct map_sessiondata*,int);
int pc_heal(struct map_sessiondata*,int,int);
int pc_res(struct map_sessiondata*);
int pc_die(struct map_sessiondata*);
int pc_calcdamage(struct map_sessiondata*, int type);
int pc_calcdam(struct map_sessiondata*);
int pc_loadmagic(struct map_sessiondata*);
int pc_isinvenspace(struct map_sessiondata*,int);
int pc_isinvenitemspace(struct map_sessiondata*,int,int);
int pc_checklevel(struct map_sessiondata*);
int pc_readreg(struct map_sessiondata*,int);
int pc_setreg(struct map_sessiondata*,int,int);
char *pc_readregstr(struct map_sessiondata*,int);
int pc_setregstr(struct map_sessiondata*,int,char*);
int pc_readglobalreg(struct map_sessiondata*,char*);
int pc_setglobalreg(struct map_sessiondata*,char*,int);
int pc_readparam(struct map_sessiondata*,int);
int pc_setparam(struct map_sessiondata*,int,int);
int pc_starttimer(struct map_sessiondata*);
int pc_timer(int,int,int id,int);
int pc_stoptimer(struct map_sessiondata*);
int pc_regen(int,int,int,int);
int pc_uncast(struct map_sessiondata*);
void pc_chkinvalid_pos( struct map_sessiondata *sd);
int pc_dcrs_itemdura(struct map_sessiondata *sd, int id);
unsigned int pc_calcstat_per( unsigned int point, int per, int *dummy);
int pc_damaged(struct map_sessiondata*, int);
int pc_getmoney(struct map_sessiondata *sd, int money);
int pc_dropmoney(struct map_sessiondata *sd, int money);
int pc_itemname_check(struct map_sessiondata *sd);
int pc_changeclass(struct map_sessiondata *sd, int class_id);
int pc_addeventtimer(struct map_sessiondata *sd,int tick,const char *name);
int pc_randomwarp(struct map_sessiondata *sd, int type);
int pc_canmove(int m, int x, int y);

#define pc_readglobalreg(sd,reg) pc_readregistry(sd,reg)
#define pc_setglobalreg(sd,reg,val) pc_setregistry(sd,reg,val)
#define pc_readglobalreg_str(sd,reg) pc_readregistry_str(sd,reg)
#define pc_setglobalreg_str(sd,reg,val) pc_setregistry_str(sd,reg,val)

/*  -- Baram doesn't need account registry
#define pc_readaccountreg(sd,reg) pc_readregistry(sd,reg,2)
#define pc_setaccountreg(sd,reg,val) pc_setregistry(sd,reg,val,2)
#define pc_readaccountregstr(sd,reg) pc_readregistry_str(sd,reg,2)
#define pc_setaccountregstr(sd,reg,val) pc_setregistry_str(sd,reg,val,2)
#define pc_readaccountreg2(sd,reg) pc_readregistry(sd,reg,1)
#define pc_setaccountreg2(sd,reg,val) pc_setregistry(sd,reg,val,1)
#define pc_readaccountreg2str(sd,reg) pc_readregistry_str(sd,reg,1)
#define pc_setaccountreg2str(sd,reg,val) pc_setregistry_str(sd,reg,val,1)
*/
enum { PC_ALIVE, PC_DIE, PC_HORSE, PC_INVIS };
#endif
