#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "warp.h"
#include "map.h"
#include "../common/malloc.h"
#define AUTOWARP_TIME 8000 // milli sec

int do_warp(struct map_sessiondata *sd, unsigned short m, unsigned short x, unsigned short y) {
	struct point v;
	struct warp_data *wd;
	//v.x=sd->bl.x;
	//v.y=sd->bl.y;
	// for naturally warping movement [Lene]
	// send walking packet [Lene]
	// --------------------------------
	v.x=x;
	v.y=y;
	v.m=m;
	wd=search_locate( &v );

	if( wd == NULL ) {
	//	printf("wtf, wd==NULL\n");
		return -1;
	}


	if( wd->minlv > sd->status.level ) {
		if(wd->minlv > sd->status.level+10) {
			return WP_LVMIN;
		} else if(wd->minlv > sd->status.level+5) {
			return WP_LVMIN2;
		} else return WP_LVMIN3;
	} else if( wd->maxlv < sd->status.level ) {
		return WP_LVMAX;
	} else {
		pc_warp(sd,wd->dest.m,wd->dest.x,wd->dest.y);
		return 0;
	}

	return 0;
}

struct warp_data *search_locate( struct point *val) {
	struct warp_data* now;
	struct warp_data* last;
	if(map[val->m].wl_head==NULL) {
//		printf("head is NULL");

		return NULL;
	}
	// accessing memory takes little time but that the little time is especially important. [Lene]
	// to decrease spending time to access memory and to stamp memory address, [Lene]
	// temporary save address in valuable 'last'. [Lene]
	for( now= map[val->m].wl_head, last=map[val->m].wl_last; now!= last; now=now->next) {

		// it has lots more speed than stamping with each valuable. [Lene]
		if(memcmp(val,&now->from,sizeof(struct point))==0) {
			return now;
		}
	}
	return NULL;
};

int read_warpgate( const char *filepath) {
	char line[1024]={0,};
	char w1[1024]={0,};
	char w2[1024]={0,};
	int warpc=0;
	char *str[1024], *p, *np;
	int i, mstr=0;
	int mapn;

	int j;
	struct warp_data *wd;
	FILE *fp=fopen(filepath,"r");
	if(fp == NULL) {
		printf("error: File not found: %s\n",filepath);
		return 0;
	}

	
	
	while(fgets(line,1023,fp)) {
		if(line[0]=='/' && line[1] == '/') continue;
		memset(str,0,sizeof(str));
		for(i=0,np=p=line;i<26 && p;i++) {

			// frommap,destm,destx,desty,range,destm,destx,desty,range,destm,destx,desty,range,destm,destx,desty,range,destm,destx,desty,range,destm,destx,desty,range
			str[i]=p;
			p=strchr(p,',');
			if(p){ *p++=0; np=p; }
		}

		if(sscanf(line,"%[^:]: %[^\r\n]",w1,w2) == 2) {
			if(strcmp(w1,"import") ==0 ) {
				if(!read_warpgate(w2)) {
					printf("error: cannot import file: %s\n",w2);
				}
				
			}
			continue; // skip this line
		}
		mapn=atoi(str[0]);
		if(!map[mapn].xs || !map[mapn].ys) {
			printf("map %d is not exist\n");
			continue;
		}
		
		for( j=1; j<6; j+=4) {
			map[mapn].warp_gate[j].m=atoi(str[j]);
			map[mapn].warp_gate[j].x=atoi(str[j+1]);
			map[mapn].warp_gate[j].y=atoi(str[j+2]);
			map[mapn].warp_gate_range[j]=atoi(str[j+3]);
		}
		
		warpc++;
	}
	printf(" %d warp gates loaded!\n",warpc);
	fclose(fp);
	return 1;
}
int read_warpdb( const char *filepath ) {
	char line[1024]={0,};
	char w1[1024]={0,};
	char w2[1024]={0,};
	int warpc=0;
	char *str[1024], *p, *np;
	int i, mstr=0;
	struct point tdest,tfrom;
	int lines=0;
	struct warp_data *wd;
	FILE *fp=fopen(filepath,"r");
	if(fp == NULL) {
		printf("error: File not found: %s\n",filepath);
		return 0;
	}

	
	
	while(fgets(line,1023,fp)) {
		lines++;
		if(line[0]=='/' && line[1] == '/') continue;
		memset(str,0,sizeof(str));
		for(i=0,np=p=line;i<9 && p;i++) {
			str[i]=p;
			p=strchr(p,',');
			if(p){ *p++=0; np=p; }
		}
		if(sscanf(line,"%[^:]: %[^\r\n]",w1,w2) == 2) {
			if(strcmp(w1,"import") ==0 ) {
				if(!read_warpdb(w2)) {
					printf("error: cannot import file: %s\n",w2);
				}
			}
			continue;
		} else {
			int i,flag;
			for(i=0;i<9;i++) {
				if(str[i]==NULL) {
					flag=1;
					break;
				}
			}
			if(flag==1) continue;
		}
		
		//		if(map[tfrom.m].) {
		//			printf("error: read_warpdb(), that map %d does not exist\n",tfrom.m);
		//			continue;
		//		} 
		
		wd= aCalloc( sizeof(struct warp_data), 1);
		tfrom.m=atoi(str[0]);
		tfrom.x=atoi(str[1]);
		tfrom.y=atoi(str[2]);
		tdest.m=atoi(str[3]);
		tdest.x=atoi(str[4]);
		tdest.y=atoi(str[5]);
		memcpy(&wd->from, &tfrom, sizeof(struct warp_data));
		memcpy(&wd->dest, &tdest, sizeof(struct warp_data));
		wd->maxlv= atoi(str[6]);
		wd->minlv= atoi(str[7]);
		wd->type= atoi(str[8]);
		wd->next=NULL;
		wd->prev=NULL;
		if(!map[tfrom.m].wl_head) {
			map[tfrom.m].wl_head= wd;
			map[tfrom.m].wl_last= wd;
			
		} else {
			wd->prev = map[tfrom.m].wl_last;
			map[tfrom.m].wl_last->next=wd;
			map[tfrom.m].wl_last=wd;
		}
		
		if(wd->maxlv == 0) wd->maxlv=99;
		if(wd->minlv == 0) wd->minlv=1;

		map[tfrom.m].flag.warp=1;
		
/*		printf("warp: %d %d %d(%d,%d,%d), %d,%d,%d, %d,%d,%d\n",
			wd->from.m,wd->from.x,wd->from.y,
			tfrom.m,tfrom.x,tfrom.y,
			wd->dest.m,wd->dest.x,wd->dest.y,
			wd->minlv,wd->maxlv,wd->type);
*/		warpc++;
	}
	printf(" %d warp tunnels loaded!\n",warpc);
	fclose(fp);
	return 1;
};

void warp_init() {
	read_warpdb( WARP_DBFILE );
}
void warp_final() {
	// we must call warp_final() before calling do_term()!
	// or memory leek!
	int i;
	for(i=0;i<MAX_MAP_PER_SERVER; i++) {
		if(map[i].flag.warp) delete_warpdatalist(i);
	}
	
}

void delete_warpdatalist( int m) {
	struct warp_data *next;
	struct warp_data *now;
	next=now=map[m].wl_head;
	while( next ) {
		next=now->next;
		if(now)
			aFree(now);
		now=next;
	}
//	aFree(md->wl_last);
}